/************************************************/
/*												*/
/*				SMALL-C COMPILER				*/
/*												*/
/************************************************/

		/*	Define the symbol table parameters	*/

#define NUMGLBS		461
#define NUMLOCS		32
#define	SYMSIZ		19

#define	STARTGLB	symtab
#define	ENDGLB		STARTGLB+NUMGLBS*SYMSIZ
#define	ENDLOC		ENDGLB+NUMLOCS*SYMSIZ

		/*	Define symbol table entry format	*/

#define	name		0
#define	ident		9
#define	type		10
#define	storage		12
#define	offset		13
#define dimension	15

#define retype		0
#define intype		1
#define orgtype		2
#define memtype		3
#define idd			4
#define symaddr		5
#define dimens		6

		/*	System wide name size (for symbols)	*/

#define	namesize 9

		/*	should not be less than 8 because of 'continue' */

		/*	Define possible entries for "type"	*/

#define OFFSET		16
#define	CHAR		1
#define	INT			2
#define DOUBLE		6
#define LONG		(DOUBLE+OFFSET)
#define	UCHAR		(CHAR+OFFSET)
#define	UINT		(INT+OFFSET)

		/*	Define possible entries for "ident".				*/
		/*														*/
		/*	variable:	v										*/
		/*	pointer:	*p, (*p)[]								*/
		/*	ppoint:		**p, *(*p)[]							*/
		/*	array:		a[][]									*/
		/*	parray:		*a[][]									*/
		/*	function:	f(), (*f)()								*/
		/*	pfunct:		*f(), *(*f)()							*/
		/*	ppfunct:	**f(), **(*f)()							*/
		/*	STRUCT:		struct name {} ...						*/
		/*	UNION:		union name {} ...						*/
		/*	MACRO:		#define replacement						*/
		/*														*/
		/*	Functions can't return addresses of multi-			*/
		/*	dimensional arrays. There are no arrays of 			*/
		/*	pointers to functions.								*/
		/*														*/
		/*	structure names have to be known before they		*/
		/*	they can be used.									*/
		

#define	variable 1
#define	pointer	2
#define ppoint (pointer+OFFSET)
#define	array 3
#define parray (array+OFFSET)
#define	function 4
#define	pfunc 5
#define	ppfunc 6
#define STRUCT 7
#define UNION (STRUCT+OFFSET)
#define MACRO 8

#define rel 1
#define abs 2
#define all 3

		/*	Define possible entries for "storage".	*/

#define global		0
#define external	1
#define typdef		external+OFFSET
#define	statik		2
#define	automatic	3

		/*	Define size of the structure component link queue.		*/
		/*	In a struct or union declaration upto linksize-depth	*/
		/*	recursive pointer declarations may occur.				*/

#define linksize 16

		/* 	Define the "while" and "for" statement queue	*/
		/*	Allows for wqtabsz / wqsiz entries				*/
		
#define	wqtabsz	32
#define	wqsiz	4
#define	wqmax	wq+wqtabsz-wqsiz

		/*	Define entry offsets in while and for queue	*/

#define	wqsp	0
#define	wqloop	1
#define	wqbreak	2
#define wqtype	3

		/*	Define the input line	*/

#define msgbufadr	128
#define	linesize	84
#define	linemax		linesize-1

		/*	Define the macro and literal pool		*/

#define litabsz		1030
#define litmax		litabsz-3
#define	macqsize 	600
#define	macmax		macqsize-1

		/*	Define statement types (tokens)	*/

#define stasm 128
#define stauto 129
#define	stbreak	130
#define stcase 131
#define stchar 132
#define	stcontinue 133
#define stdefault 134
#define stdo 135
#define stdouble 136
#define stelse 137
#define stextern 138
#define stfloat 139
#define stfor 140
#define	stif 141
#define stint 142
#define stlong 143
#define stregister 144
#define streturn 145
#define stshort 146
#define stsizeof 147
#define ststatic 148
#define ststruct 149
#define stswitch 150
#define sttypedef 151
#define stunion 152
#define stunsigned 153
#define stwhile 154

		/*	All characters are unsigned	*/

#define char unsigned char
#define WORDS 27

		/*	The list of reserved words (keywords, tokens)	*/

static char *word[WORDS] =
	{"asm","auto", "break", "case", "char", "continue", "default",
	"do", "double", "else", "extern", "float", "for", "if",	"int",
	"long", "register", "return", "short", "sizeof", "static",
	"struct", "switch", "typedef", "union", "unsigned", "while"
	};

		/*	Now reserve some storage words	*/

static	char	*symtab,			/* symbol table */
				*locptr,*strucptr,	/* ptrs to next entries */
				*newloc,			/* ptr to symbols of current local level */
				*(*linklist)[2];	/* ptr to ptrs to recursive structures */
static	int		glbcount=0,			/* counts global symbols */
				*wq,				/* while / for queue */
				*wqptr;				/* ptr to next entry */
static	char	*litq;				/* literal pool */
static	int		litptr=0,			/* ptr to next entry */
				litdist=0;			/* dist of const from start of lit pool */
static	char	*macq;				/* macro string buffer */
static	int		macptr=1;			/* and its index */
static	char	*line,				/* parsing buffer */
				*mline;				/* temp macro buffer */
static	int		lptr=0,mptr=0;		/* ptrs into each */


/*	Misc storage. NOTE THAT elem .. link HAVE TO BE KEPT TOGETHER	*/
/*	AND elem HAS TO STAY THE FIRST NAME. THESE (SAVENUM) VARIABLES	*/
/*	ARE SAVED BY intcopy() FOR RECURSIVE USES OF declare().			*/

#define SAVENUM	7

static	int		elem[4]={},		/* elements in declare()ed object and copies */
				need=0,			/* need-identifier-flag set by declare() */
				fndef=0;		/* function definition following */
static	char	*link=0;		/* current link */
static	int		linkptr=0,		/* counts links (recursions) */
				linklevel=0,	/* If 0, links are performed */
				argnum=1,		/* next argument to be used */
				nxtlab=0,		/* next avail label # */
				litlab=0,		/* label # assigned to literal pool */
				Zsp=0,			/* compiler relative stk ptr */
				undeclared,		/* # function arguments not yet declared */
				ncmp=0,			/* # open compound statements */
				errcnt=0,		/* # errors in compilation */
				errstop=1,		/* stop on error */
				eof=0,			/* set non-zero on final input eof */
				outdev=0,		/* output drive, or '$' for screen, else 0 */
				input=0,		/* iob # for input file */
				output=0,		/* iob # for output file (if any) */
				iinput=0,		/* iob # for "include" file */
				class=0,		/* stor. class (0=global) static,auto,extern */
				ctext=0,		/* non-0 to intermix c-source and err msgs */
				cmode=1,		/* non-zero while parsing c-code */
								/* zero when passing assembly code */
				locked=0,		/* non-zero, if false #if(n)def clause */
				mainflg=1,		/* output is to be first asm file */
				fnstart=0,		/* line# of start of current fn. */
				lineno=0,		/* line# in current file */
				savestart,		/* copy of fnstart */
				saveline,		/* copy of lineno */
				profile=0,		/* nonzero if profile wanted */
				trace=0,		/* nonzero if traceback info needed */
				firstfct,		/* label for 1st function */
				lastfct,		/* label for most recent fct */
				fname,			/* label for name of current fct */
				argc;
static	char	**argv,
				*argname,		/* current argument and filename */
				*ffname,		/* file name [20] each */
				*currfile=0,	/* name of current file */
				*currfn=0,		/* ptr to symtab entry for current fn. */
				*cptr;			/* work ptr to any char buffer */

/*									*/
/*	Compiler begins execution here	*/
/*									*/
static main(argc,argv) int argc; char *argv[];
	{
	allocate(argc,argv);
	ask();							/* get user options */
	openin();						/* and initial input file */
	openout();						/* get an output file */
	header();						/* intro code */
	parse(); 						/* process ALL input */
	trailer();						/* follow-up code */
	closeout();						/* close the output (if any) */
	errsummary();					/* summarize errors */
	}

static allocate(count,values) int count; char *values[];
	{
	unsigned int avail();
	char *alloc();
	pnl(); pmessage(0); psp();
	if ( (macq=alloc(macqsize)) &&
		(argname=alloc(20)) &&
		(ffname=alloc(20)) &&
		(litq=alloc(litabsz)) &&
		(wqptr=wq=alloc(wqtabsz*INT)) &&
		(line=alloc(linesize)) &&
		(mline=alloc(linesize)) &&
		(linklist=alloc(linksize*INT*2)) &&
		(symtab=alloc(SYMSIZ*(NUMGLBS+NUMLOCS))) ) ;
		/* ^ must be allocated last */
	else 
		{lmessage(72); exit();
		}
	putdec(avail()); psp();
	lmessage(41); pnl();
	newloc=locptr=ENDGLB;			/* clear local symbols */
	strucptr=ENDLOC;
	argc=count;
	argv=values;
	}

/*							*/
/*	Dump the literal pool	*/
/*							*/
static dumplits(sname) char *sname;
	{
	static int i,j,k,mode; k=0;
	if (!litptr) return;						/* if nothing there, exit...*/
	if (!sname) {printlabel(litlab); col();}	/* print literal label */
	else nicename(sname);
	while (k<litptr)
		{
		i=*(int *)(litq+k); k+=2;
		if ((mode=litq[k++])==all) {defstorage(i); continue;}
		if (mode==rel)
			{while (i)
				{j=4; defword();
				while (j--)
					{distance(sname,*(int *)(litq+k)); k+=2;
					if (j && (i+=2)) com();
					else {nl(); break;}
					}
				}
			continue;
			}
		if (i==-2) {defword(); outdln(*(int *)(litq+k)); k+=2; continue;}
		while (i<0)
			{j=16; defbyte();
			while (j--)
				{outdec(litq[k++]);				/* no masking: unsigned char */
				if (j && ++i) com();
				else {nl(); break;}
				}
			}
		while (i>0)
			{j=60; defbyte();
			while (j>=0)
				{
				if (nicechar(litq[k]))
					{quo(); --j;
					while (nicechar(litq[k]))
						{outbyte(litq[k++]);
						if (--j<0 || !--i) break;
						}
					quo(); --j;
					if (j>=0 && i) com();
					else {nl(); break;}
					}
				while (!nicechar(litq[k]))
					{outdec(litq[k++]);
					if ((j-=4)>=0 && --i) com();
					else {nl(); break;}
					}
				if (!i) break;
				}
			}
		}
	}

static nicename(sname) char *sname;
	{
	outname(sname); col();
	if (!class) col();
	if (strlen(sname)>5-!class) nl();
	}

static nicechar(c) int c;
	{
	/* return (c>=' ' && c<='~' && c!='"'); */
	asm	{
		POP	BC
		POP	HL
		PUSH	HL
		PUSH	BC
		LD	A,L
		LD	HL,0
		CP	' '
		RET	C
		CP	'"'
		RET	Z
		CP	'~'+1
		RET	NC
		INC	HL
		};
	}

/*				     PROCESS ALL INPUT TEXT						*/
/* At this level, only static declarations, defines, includes,	*/
/* and function definitions are legal...						*/

static parse()
	{
	static int id,typ;
	while (!eof)				/* do until no more input */
		{if (istoken(stasm)) doasm();
		else
			{if (getclass()==automatic) illclass();
			if (typename(class,&id,&typ)) declglb(id,typ);
			else {error(23); kill();}
			}
		blanks();				/* force eof if pending */
		}
	}

/*								*/
/*	Report errors for user		*/
/*								*/
static errsummary()
	{
	if (ncmp) error(1);
	if (!errcnt) puts("No");
	else putdec(errcnt);
	psp(); pmessage(2);
	psp(); putdec(glbcount);
	psp(); lmessage(10);
	bell();
	}

/*						*/
/*	Abort compilation	*/
/*						*/
static abort()
	{
	lmessage(3);
	exit();			/* closes all files */
	}

static nextarg()
	{
	static char *str;
	static int i;
	while (argnum<argc)
		{str=argv[argnum++];
		if (str[0]=='-' || str[0]=='/') continue;
		for (i=0; i<10 && str[i]!='.'; ++i) argname[i]=str[i];
		argname[i]=0; return;
		}
	return eof=1;
	}

static ask()						/* fetch arguments */
	{
	static char c,*arg;
	static k,argcnt=1,nofile=1;
	kill();
	while (argcnt<argc)
		{arg=argv[argcnt++];
		if (arg[0]=='-' || arg[0]=='/')
			{k=1;
			while (c=arg[k++])
				{if (arg[k]!=':')
					{switch (c)
						{case 'C':	ctext=1; break;
						case 'M':	mainflg=0; break;
						case 'E':	errstop=0; break;
						case 'P':	profile=1;
						case 'T':	trace=1; break;
						default:	lmessage(4); break;
					    }
					}
				else
					{if(c>='A' && c<='P' || c=='$')
					    {outdev=c; pmessage(100); psp();
				    	putchar(c); putln(":");
					    }
					else {putchar(c); lmessage(5);}
					++k;
					}
				}
			}
		else nofile=0;
		}
	if (nofile) {lmessage(6); bell(); abort();}
	if (trace) lastfct=firstfct=getlabel();
	kill();				/* erase line */
	}
 
/*							*/
/*	Get (next) input file	*/
/*							*/
static openin()
	{
	kill();
	while (!input)
		{nextarg();
		if (eof) return;
		strcpy(ffname,argname);
		strcat(ffname,".C");
		if (input=fopen(ffname,"i"))
			{newfile(ffname);
			puts(ffname);
			}
		else
			{pmessage(101); psp();
			puts(ffname); psp();
			pmessage(102);
			}
		putln("\5");
		}
	}

/*						*/
/*	Get output filename	*/
/*						*/
static openout()
	{
	kill();
	if (eof) return;
	strcpy(ffname,argname);
	if (outdev)
		{if (ffname[1]==':') *ffname=outdev;
		else
			{*ffname=outdev; ffname[1]=':';
			ffname[2]=0; strcat(ffname,argname);
			}
		}
	strcat(ffname,".Z80");
	if (outdev!='$')
		{if (!(output=fopen(ffname,"o"))) error(-105); 
		}
	strcpy(ffname,argname);
	strcat(ffname,".C");
	}

/*							*/
/*	Reset line count, etc.	*/
/*							*/
static newfile(nam) char *nam;
	{
	lineno  =		/* no lines read */
	fnstart = 0;	/* no fn. start yet. */
	currfile = nam;
	}

/*							*/
/*	Close the output file	*/
/*							*/
static closeout()
	{
	if (output)
		{if (fclose(output)) lmessage(9);
		output=0;
		}
	}

/*										*/
/* Declare / define a static variable	*/
/*										*/
static declglb(given,typ) int given,typ;
	{
	static char sname[namesize];
	static int id,size;
	do	{
		id=declare(sname,given,&typ);
		if (!*sname) break;
		if (isfunc(id))
			{if (fndef)
				{if (class==external) class=global;
				newfunc(sname,id,typ); return;
				}
			if (class==statik) illclass();
			declfunc(sname,id,typ,class);
			continue;
			}
		if (findglb(sname)) multidef();
		strucfunc(id,typ);
		if (blank('=') && !(isextern() || typ<=0 && (id==array || isvar(id))))
			{gch();
			litptr=litdist=0;
			id=initialize(sname,id,typ);
			dumplits(sname);
			litptr=litdist=0;
			}
		else
			{if (chmatch('=')) {error(81); kill();}
			if (!isextern())
				{nicename(sname);
				defstorage(getsize(id,typ));
				}
			}
		addglb(sname,id,typ,class,0,elem[0],elem[1]);
		} while (comma());
	class=global;
	ns();
	}

static declfunc(sname,id,typ,class) char *sname; int id,typ,class;
	{
	if (findglb(sname))
		{if (!isfunc(cptr[ident])) multidef();
		else
			{if (cptr[storage]) multidef();
			if (*(int*)(cptr+type)!=typ) error(11);
			if (cptr[ident]!=id) error(12);
			if (*(int *)(cptr+dimension+2)!=elem[1]) error(13);
			cptr[storage]=class;
			}
		}
	else addglb(sname,id,typ,class,0,elem[0],elem[1]);
	strucfunc(id,typ);
	return cptr;				/* ^ becomes argument count */
	}

static strucfunc(id,typ) int id,typ;
	{
	if (spec(id)==function && typ<=0) illstruc();
	}

/* 		DECLARE LOCAL VARIABLES (i.e. define for use)	*/
/* works just like "declglb" but modifies machine stack	*/
/* and adds symbol table entry with appropriate			*/
/* stack offset to find it again						*/

static declloc(given,typ) int given,typ;
	{
	static char sname[namesize];
	static int id,value,size,sclass;
	sclass=class;
	do	{
		id=declare(sname,given,&typ);
		if (!*sname) break;
		if (isfunc(id))
			{if (sclass==automatic) illclass();		/* extern dealed with */
			declfunc(sname,id,typ,sclass);			/* by declglb */
			continue;
			}
		if (!class) class=automatic;
		if (findloc(sname,(class==statik)?ENDGLB:newloc)) multidef();
		strucfunc(id,typ);
		if (blank('=') && !(isextern() || typ<=0 && (id==array || isvar(id))))
			{gch();
			initialize(sname,id,typ);	/* adds symbol to local table */
			}
		else
			{if (chmatch('=')) {error(81); kill();}
			size = (isextern())? 0: getsize(id,typ);
			value=(class==statik)? addlit(size,0,all): Zsp=modstk(Zsp-size);
			addloc(sname,id,typ,class,value,elem[0],elem[1]);
			}
		} while (comma());
	class=global;
	ns();
	}

static initconst(val) int *val;
	{
	static ftyp;
	int num1();
	return (ftyp=fnumber(val))? ftyp
		: (number(val,num1,1))? INT
		: (quoted(val))? UINT
		: (error(14),INT);
	}

static initialize(sname,id,typ) char *sname; int id,typ;
	{
	int *sense();
	static int isptr,sawbr,value,typ2,end,loaded,swapped;
	static int *iaddr,litd,litp,stat,el[3],icount,ic,sp;
	static unsigned int val,size;
	el[0]=elem[0]; el[1]=elem[1];
	if (nullsize(elem))
		{if (null(elem[0])) el[0]=32767;
		if (null(elem[1])) el[1]=32767;
		}
	value=litdist; iaddr=0;
	if ((stat=class!=automatic) && !nullsize(elem) && elem[0])
		{if (id==array && isint(typ) || id==parray)
			{iaddr=litq+litptr+3;
			addlit(0,getsize(id,typ),(id==parray && !isint(typ))? rel: abs);
			}
		}
	sense(el);
	if (!isarray(id)) el[0]=el[1]=1;
	if (swapped=(el[1]==1 && el[0]!=1))
		{swapdim(el); swapdim(elem);
		}
	sp=Zsp; size=0;
	el[2]=el[1]; loaded=ic=end=sawbr=0;
	if (chmatch('{')) {++sawbr; end=blank('}');}
	do
		{el[1]=el[2]; icount=0;
		if (!end) loaded=0; 
		if (chmatch('{')) {++sawbr; end=blank('}');}
		do
			{if (end && !loaded && !stat) {mainload(0); loaded=1;}
			if ((isptr = (id==parray || ispointer(id))) || isint(typ))
				{
				size=INT;
				if (stat)
					{val=0; litp=litptr;
					if (id==pointer) addlit(value+2,INT,rel);
					litd=litdist;
					if (!end)
						{typ2=initconst(&val);
						if (litd!=litdist)
							{if (isint(typ) || id==ppoint) error(15);
							else if (bigtype(typ)) /* Must be pointer or parray */
								{if (typ2!=typ) error(16);}
							else if (bigtype(typ2)) error(17);
							}
						}
					if (iaddr) *iaddr++=val;
					else
						{if (litdist!=litd)
							{if (nullsize(elem)) error(18);
							if (id!=pointer) addlit(val,INT,rel);
							}
						else if (id==pointer)
							{litq[litp+2]=abs; *(int *)(litq+litp+3)=val;}
						else addlit(val,INT,abs);
						}
					}
				else
					{if (end)
						{if (!null(elem[1]) && el[1]>6 || ic-icount>6)
							{if (null(elem[1])) el[1]=ic-icount;
							setstack(el[1],2);
							icount+=el[1]-1; el[1]=1;
							}
						else mainpush();
						}
					else
						{force(isptr?UINT:typ,expression());
						mainpush();
						}
					}
				}
			else if (bigtype(typ))
				{size=DOUBLE;
				if (stat)
					{if (end) addlit(0,DOUBLE,abs);
					else
						{litd=litdist;
						typ2=initconst(&val);
						if (litd=litdist-litd)
							{if (typ2!=typ) error(19);
							if (litd<DOUBLE) addlit(0,DOUBLE-litd,abs);
							}
						else
							{addlit(val,DOUBLE,abs);
							if (islong(typ))
								{*(int*)(litq+litptr-(DOUBLE-INT)) =
									-((int)val<0);
								}
							else *(double*)(litq+litptr-DOUBLE) = (int) val;
							}
						}
					}
				else
					{if (end)
						{if (!null(elem[1]) && el[1]>2 || ic-icount>2)
							{if (null(elem[1])) el[1]=ic-icount;
							setstack(el[1]*3,2);
							icount+=el[1]-1; el[1]=1;
							}
						else {mainpush(); mainpush(); mainpush();}
						}
					else {force(typ,expression()); dpush();}
					}
				}
			else					/* must be CHAR or UCHAR */
				{size=CHAR;
				if (stat)
					{if (end)
						{addlit(0, (!null(elem[1]))?
								(icount+=el[1],el[1])
								:(ic? (el[1]=ic-icount,icount=ic,el[1])
									  :icount=1),abs);
						el[1]=1;}
					else 
						{litd=litdist;
						if (bigtype(initconst(&val))) error(17);
						if (litd=litdist-litd)
							{icount+=litd; el[1]-=(litd-1);} /* was string */
						else
							{addlit(val,((val>>8)?(icount+=2,--el[1],2)
								:(++icount,1)),abs);
							}
						if (el[1]<=0)
							{el[1]=1;
							if (!null(elem[1])) error(20);
							}
						}
					--icount;
					}
				else
					{if (end)
						{if (!null(elem[1]) && el[1]>3 || ic-icount>3)
							{if (null(elem[1])) el[1]=ic-icount;
							setstack(el[1],1);
							icount+=el[1]-1; el[1]=1;
							}
						else {mainpush(); Zsp=modstk(Zsp+1);}
						}
					else
						{litd=litdist;
						if (bigtype(expression())) error(17);
						if (litd=litdist-litd)
							{swap(); Zsp=modstk(Zsp-litd);
							mainload(litd); library("CCCOPY");
							icount+=litd-1; el[1]-=(litd-1);
							if (el[1]<=0)
								{el[1]=1;
								if (!null(elem[1])) error(20);
								}
							}
						else
							{outline("LD\tH,L");
							mainpush(); Zsp=modstk(Zsp+1);
							}
						}
					}
				}
			++icount;
			if (endinit(el,1,&sawbr,&end) && icount>=ic) break;
			} while (--el[1]);
		end=0;
		if (!ic) ic=icount;
		if (ic!=icount) error(21);
		if (endinit(el,0,&sawbr,&end)) break;
		} while (--el[0]);
	while (sawbr--) needbrack('}');
	if (swapped) swapdim(elem);
	if (null(elem[1])) elem[1]=ic;
	if (currfn) addloc(sname,id,typ,class,stat?value:Zsp,elem[0],elem[1]);
	if (!stat && (sp-=Zsp)>size)
		{mainload(sp);
		zload(size); library("CCSWAP");
		}
	return id;
	}

static setstack(count,size) unsigned count; int size;
	{
	static int label;
	Zsp-=count*size;
	bload(count);
	printlabel(label=getlabel()); col();
	while (size)
		{push();
		if ((size-=2)<0) {outline("INC\tSP"); break;}
		}
	outtab("DEC\tBC\n\tLD\tA,B\n\tOR\tC\n\tJR\tNZ,");
	printlabel(label); nl();
	}

static endinit(el,level,sawbr,end) int el[],level,*sawbr,*end;
	{
	static int res;
	res=0;
	if (*sawbr) if (chmatch('}')) {--*sawbr; *end=1;}
	if (!*sawbr && endst()) *end=1;
	if (null(elem[level]))
		{el[level]=32767;
		if (*end) res=1;
		else if (!comma()) res=1;
		}
	else if (!*end && el[level]>1) *end=!comma();
	return res;
	}
	
static addlit(val,count,mode) unsigned val; int count,mode;
	{
	static int n;
	if (litptr+count+3<litmax)
		{*(int *)(litq+litptr)=(count? -count:val);
		litq[(litptr+=3)-1]=mode;
		n=count; while (n--)
			{litq[litptr++]=val; val>>=8;}
		if (!count) count=val;
		litdist+=count;
		return litdist-count;
		}
	error(-22);
	}

static getsize(id,typ) int id,typ;
	{
	static unsigned size;
	if (ispointer(id)) size=INT;
	else 
		{size = null(elem[0])? 0 : (elem[0]? elem[0] : 1);
		size *= (null(elem[1]) || !elem[1]) ? 1 : elem[1];
		size *= (id==parray)? INT: typesize(typ);
		}
	return size;
	}

static int *sense(el) int el[];
	{
	if (null(el[0]) || !el[0]) el[0]=1;
	if (null(el[1]) || !el[1]) el[1]=1;
	return el;
	}

static swapdim(el) int el[];
	{
	static int save;
	save=el[0];
	el[0]=el[1];
	el[1]=save;
	}
	
static nullsize(el) int el[];
	{
	return null(el[0]) || null(el[1]);
	}

static null(dim) int dim;
	{
	return dim==-1;
	}

/*				BEGIN A FUNCTION			*/
/* Called from "parse" this routine tries	*/
/* to make a function out of what follows.	*/

static newfunc(sname,id,typ) char *sname; int id,typ;
	{
	static char *prev;		/* ptr to symbol table entry for most recent arg */
	static int *iptr,lg;	/* argument size (in bytes) */
	static unsigned where;	/* offset to arg in stack (zero for last one) */
	fnstart=lineno;			/* remember where fn began */
	litlab=getlabel();		/* first label=literal pool */ 
	currfn=declfunc(currfn=sname,id,typ,statik);
	puts("\eA   @ "); puts(currfn); puts("()\5\r");
	if (trace)
		{fname=lastfct;
		defword(); printlabel(lastfct=getlabel()); nl();
		defbyte(); outln("0,0,0");
		printlabel(fname); col();
		defbyte(); quo();
		outs(currfn); quo(); outln(",0");
		}
	outname(currfn); col();
	if (class!=statik) col();
	nl(); class=global;					/* reset class for getarg */
	newloc=locptr=ENDGLB;				/* "clear" local symbol table */
	prev=		  						/* initialize ptr to prev argument */
	undeclared=0;						/* init arg count */
	while (!blank(')'))					/* then count args */
		{								/* any legal name bumps arg count */
		if (identifier(sname))
			{if (findloc(sname,newloc)) multidef();
			else						/* add link to argument chain */
			    {prev=addloc(sname,0,INT,automatic,prev,0,0);
			    ++undeclared;
			    }
			}
		else illname();
		if (blank(')') || endst()) break;
		needcomma();
		}
	checkargs(currfn,offset,undeclared,47);
	needbrack(')');
	if (trace)
		{
		Zsp-=2;
		immed(); printlabel(fname); nl();
		mainpush(); library("CCREGIS");
		}
	while (undeclared)		/* now let user declare types of those arguments */
		{
		if (typename(0,&id,&typ)) {getargs(id,typ); ns();}
		else {error(24); break;}
		}
	where=2;
	while (prev)
		{			/* all args except DOUBLE are 2 bytes long (even char) */
		lg=(isvar(prev[ident]) && bigtype(*(int*)(prev+type)))? DOUBLE: INT;
		iptr=prev+offset;
		prev=*iptr;						/* follow ptr to prev. arg */
		*iptr=where;					/* insert offset */
		where+=lg;						/* calculate next offset */
		}
	checkargs(currfn,offset+1,where/2-1,48);
	needbrack('{');
	if (!compound()) leave();
	Zsp=0;
	newloc=locptr=ENDGLB;				/* deallocate all locals */
	dumplits(0);						/* dump literal pool for this fn. */
	currfn=litptr=litdist=0;			/* not in fn. any more; re-init pool */
	}

/*					DECLARE ARGUMENT TYPES					*/
/* called from "newfunc" this routine adds an entry in the	*/
/* local symbol table for each named argument 				*/

static getargs(given,typ) int given,typ;
	{
	static int id;
	static char sname[namesize],*argptr;
	while (undeclared)
		{
		if (isarray(id=declare(sname,given,&typ)))
			id=(id&OFFSET)|pointer;
		strucfunc(id,typ);
		if (typ<=0 && isvar(id)) illstruc();
		if (*sname && (argptr=findloc(sname,newloc)))
			{argptr[ident]=id; *(int*)(argptr+type)=typ; /* storage above */
			*(int *)(argptr+dimension)=elem[0];
			*(int *)(argptr+dimension+2)=elem[1];
			--undeclared;
			}
		else error(25);
		if (endst()) return;
		if (undeclared) needcomma();
		}
	}

static checkargs(fnptr,off,count,err)
char *fnptr; unsigned off,count; int err;
	{
	return
		(fnptr[off] && fnptr[off]-1!=count)? (error(err),0) :
		fnptr[off]=count+1;
	}

/*				STATEMENT PARSER				*/
/* called whenever syntax requires a statement.	*/
/* This routine performs that statement 		*/
/* and returns a number telling which one 		*/

static statement()
	{
	if (!eof)
		{if (cpm(11,0) & 1) if (getchar()==3) abort();
		if (chmatch('{')) return compound();
		if (blanks()<128 || cheq(stsizeof))
			{if (chmatch(';')) ;
			else {exprlist(); ns();}
			}
		else switch (skiptoken())
			{case stif:			doif(); break;
			case stwhile:		dowhile(stwhile); break;
			case streturn:		doreturn(); ns(); return 1;
			case stfor:			dofor(); break;
			case stbreak:		dobreak(); ns(); break;
			case stdo:			dowhile(stdo); ns(); break;
			case stcontinue:	docont(); ns(); break;
			case stswitch:		doswitch(); break;
			case stasm:			doasm(); break;
			default:			error(26); kill(); break;
			}
		}
	return 0;
	}

/*					COMPOUND STATEMENT					*/
/*   allow any number of statements to fall between {} 	*/

static compound()
	{
	char *oldloc=newloc=locptr;
	int ret=0,id,typ,fsp=Zsp;
	++ncmp;
	if (!chmatch('}'))
		{
		while (typename(getclass(),&id,&typ) && !eof)
			{if (class==external) declglb(id,typ);
			else declloc(id,typ);
			}
		while (!chmatch('}'))
			{if (eof) break;
			ret=statement();
			}
		}
	--ncmp;
	Zsp = ret? fsp : modstk(fsp);
	newloc=locptr=restore(oldloc);
	return ret;
	}

static getclass()
	{
	return class =
		istoken(ststatic)? statik :
		istoken(stextern)? external :
		istoken(sttypedef)? typdef :
		istoken(stregister)? automatic :
		istoken(stauto)? automatic :
		global;
	}

/*					*/
/*	"if" STATEMENT	*/
/*					*/
static doif()
	{
	int flab1=getlabel(),flab2;		/* get label for false branch */
	test(flab1);					/* get expression, and branch false */
	statement();					/* if true, do a statement */
	if (!istoken(stelse))			/* if...else ? */
									/* simple "if"...print false label */
		{
		jlabel(flab1);
		return;						/* and exit */
		}
									/* an "if...else" statement. */
	jump(flab2=getlabel());			/* jump around false code */
	jlabel(flab1);					/* print false label */
	statement();					/* and do "else" clause */
	jlabel(flab2);					/* print true label */
	}

/*						*/
/*	"while" AND "do"	*/
/*		STATEMENT		*/
/*						*/
static dowhile(dow) int dow;
	{
	int wq[wqsiz],dolab;			/* allocate local queue */
	addwhile(wq,dow);				/* add entry to queue */
	if (dow==stwhile)
		{
		jlabel(wq[wqloop]);
		test(wq[wqbreak]);			/* while: see if true */
		}
	else jlabel(dolab=getlabel());
	statement();
	if (dow==stdo)
		{
		jlabel(wq[wqloop]);
		if (istoken(stwhile)) test(wq[wqbreak]);		
/*		else error(27);		*/
		jump(dolab);
		}
	else jump(wq[wqloop]);			/* loop to label */
	jlabel(wq[wqbreak]);			/* exit label for break */
	delwhile(wq);					/* delete queue entry */
	}

/*						*/
/*	"switch" STATEMENT	*/
/*						*/
static doswitch()
	{
	int next,around,wq[wqsiz];		/* allocate local queue */
	addwhile(wq,stswitch);			/* add entry to queue */
	next=wq[wqloop];
	around=getlabel();
	needbrack('(');
	checkint(expression());
	needbrack(')');
	needbrack('{');
	swap();
	while (!chmatch('}'))
		{if (istoken(stcase))
			{jlabel(next);
			zpush();
			checkint(expression());
			nc();
			zpop();
			jumpnz(next=getlabel());
			sw(&around);
			}
		else if (istoken(stdefault))
			{nc();
			jlabel(next);
			next=getlabel();
			sw(&around);
			}
		else error(28);
		}
	jlabel(next);
	jlabel(around);
	jlabel(wq[wqbreak]);			/* exit label */
	delwhile(wq);					/* delete queue entry */
	}

static sw(around) int *around;
	{
	jlabel(*around);
	while (!(blank('}') || cheq(stcase) || cheq(stdefault)))
		statement();
	outtab("JR\t");
	printlabel(*around=getlabel());
	nl();
	}

/*					*/
/*	"for" STATEMENT	*/
/*					*/
static dofor()
	{
	int wq[wqsiz],
	ftest=getlabel(),				/* label for test expr */
	fstat=getlabel();				/* statement label */
	addwhile(wq,stfor);				/* add entry to queue for "break" */
	needbrack('(');
	if (!endst()) exprlist();		/* initialization */
	ns();
	jlabel(ftest);
	if (!endst())
		testjump(wq[wqbreak],expression());
	ns();
	jump(fstat);					/* jump to statement */
	jlabel(wq[wqloop]);				/* loop label */
	if (!chmatch(')'))
		{exprlist();				/* reinitialization */
		needbrack(')');
		}
	jump(ftest);					/* jump to test */
	jlabel(fstat);					/* statement label */
	statement();
	jump(wq[wqloop]);				/* loop to reinitialization */
	jlabel(wq[wqbreak]);
	delwhile(wq);					/* delete queue entry */
	}

/*						*/
/*	"return" STATEMENT	*/
/*						*/
static doreturn()
	{
	if (!endst())						/* if not end of statement, */
		{if (ispfunc(currfn[ident]))	/* get an expression */
			force(UINT,expression());	/* returning pointer ? */
		else force(*(int*)(currfn+type),exprlist());
		}
	leave();
	}
/*						*/
/*	LEAVE A FUNCTION	*/
/*						*/
static leave()
	{
	if (trace) library("CCLEAVI");
	modstk(0);							/* clean up stk */
	zret();								/* and exit function */
	}

/*						*/
/*	"break" STATEMENT	*/
/*						*/
static dobreak()
	{
	static int *ptr;						/* see if any loops/switches */
	if (ptr=readwhile())
		{
		modstk(ptr[wqsp]);
		jump(ptr[wqbreak]);					/* jump to exit label */
		}
	else error(29);
	}
/*							*/
/*	"continue" STATEMENT	*/
/*							*/
static docont()
	{
	static int *ptr;				/* see if any loops are open */
	ptr=wqptr;
	while (ptr!=wq)
		{
		ptr-=wqsiz;
		if (ptr[wqtype]==stswitch) continue;
		modstk(ptr[wqsp]);
		jump(ptr[wqloop]);
		return;
		}
	error(30);
	}

static addwhile(ptr,st) int ptr[],st;
	{
	static int k;
	ptr[wqsp]=Zsp;					/* and stk ptr */
	ptr[wqloop]=getlabel();			/* and looping label */
	ptr[wqbreak]=getlabel();		/* and break label */
	ptr[wqtype]=st;
	if (wqptr==wqmax) error(31);
	else {k=0; while (k<wqsiz) *wqptr++=ptr[k++];}
	}

static delwhile(ptr) int ptr[];
	{
	if (readwhile()) wqptr-=wqsiz;
	}

static readwhile()
	{
	return (wqptr==wq)? 0 : wqptr-wqsiz;
	}

/*				"asm" PSEUDO-STATEMENT				*/
/* enters mode where assembly language statements	*/
/* are passed intact through parser					*/

static doasm()
	{
	needbrack('{');
	cmode=0;							/* mark mode as "asm" */
	while (!eof)
		{if (chmatch('}'))
			{cmode=1;					/* then back to parse level */
			doctext();
			break;
			}
		outln(line);
		lptr=strlen(line);
		}
	ns();
	}

/*				PERFORM A FUNCTION CALL				*/
/* called from heirb, this routine will either call */
/* the named function, or if the supplied ptr is	*/
/* zero, will call the contents of HL				*/

static callfunc(ptr) char *ptr;				/* symbol table entry (or 0) */
	{
	int nargs=0,args=0,pushed=0;			/* already saw open paren */
	if (!ptr && !blank(')'))
		{mainpush(); pushed=1;				/* calling HL */
		}
	while (!blank(')'))
		{if (endst()) break;
		if (bigtype(expression()))
			{if (pushed) dpush2(); 	/* save addr */
			else dpush();
			nargs+=DOUBLE;
			}
		else
			{if (pushed) swapstk();	/* save addr */
			mainpush();				/* push argument */
			nargs+=INT;
			}
		++args;
		if (!comma()) break;
		}
	if (ptr)
		{if (nospread(ptr))
			{outtab("LD\tA,");
			outdln(nargs>>1);
			}
		else if (ptr<ENDGLB)
			{if (checkargs(ptr,offset,args,47))
				checkargs(ptr,offset+1,nargs/2,48);
			}
		zcall(ptr);
		}
	else
		{if (pushed) mainpop();
		library("CCJUMP");
		}
	Zsp=modstk(Zsp+nargs);			/* clean up arguments */
	needbrack(')');
	}

static nospread(sym) char *sym;
	{
	static char p[]="printf";
	static char s[]="scanf";
	return (aneq(sym,p) || aneq(sym,s))? 1
		: (*sym!='s' && *sym!='f')? 0
		: aneq(sym+1,p) || aneq(sym+1,s);
	}

static junk()
	{
	if (skiptoken()) return;
	if (an(ch())) {while (an(ch())) gch(); return;}
	while (ch())
		{if (an(ch()) || isspace(ch()) || cheq(';')) break;
		gch();
		}
	}

static unsigned hash(sname) char *sname;
	{
	static unsigned h,c;
	h=*sname;
	while (c=*(++sname)) h+=h+c;
	return h % NUMGLBS;
	}

/* cptr is set to entry if found, or appropriate empty slot if not */
static findglb (sname) char *sname;
	{
	cptr=STARTGLB+hash(sname)*SYMSIZ;
	while (!aneq(sname,cptr))
		{if (!*cptr) return 0;
		if ((cptr+=SYMSIZ)==ENDGLB) cptr=STARTGLB;
		}
	return cptr;
	}

static addglb(sname,id,typ,store,off,dim1,dim2)
char *sname; int id,typ,store,off,dim1,dim2;
	{
	if (!findglb(sname))
		{if (++glbcount>=NUMGLBS) error(-32);
		addsym(&dim2);
		}
	return cptr;
	}

static findtype(sname) char *sname;
	{
	char *ptr=findsym(sname);
	return (ptr[storage]==typdef)*ptr;
	}

static findsym(sname) char *sname;
	{
	char *ptr=findloc(sname,ENDGLB);
	return ptr? ptr: findglb(sname);
	}

static findloc(sname,start) char *sname,*start;
	{
	static char *ptr;
	ptr=locptr;
	while (ptr!=start)
		{
		if (aneq(sname,ptr-=SYMSIZ)) return ptr;
		}
	return 0;
	}

static restore(oldloc) char *oldloc;
	{
	static char *head;
	static int i;
	head=oldloc;
	while (oldloc<locptr)
		{
		if (oldloc[storage]==statik)
			{i=SYMSIZ; while (i--) *head++=*oldloc++;}
	 	else oldloc+=SYMSIZ;
	 	}
	 return head;
	 }

static addloc(sname,id,typ,store,off,dim1,dim2)
char *sname; int id,typ,store,off,dim1,dim2;
	{
	if (!(cptr=findloc(sname,newloc)))
		{if (locptr>=ENDLOC) error(-33);
		cptr=locptr;
		addsym(&dim2);
		locptr+=SYMSIZ;
		}
	return cptr;
	}

static findstruc(sname) char *sname;
	{
	static char *ptr;
	ptr=strucptr;
	while (ptr!=ENDLOC)
		{
		if (aneq(sname,ptr-=SYMSIZ)) return ptr;
		}
	return 0;
	}

static addstruc(sname,id,typ,store,off,dim1,dim2)
char *sname; int id,typ,store,off,dim1,dim2;
	{
	if (!(cptr=findstruc(sname)))
		{if ((cptr=alloc(SYMSIZ)) != strucptr) error(-72);
		addsym(&dim2);
		strucptr+=SYMSIZ;
		}
	return cptr;
	}

static addsym(args) int *args;
	{
	static char *sname,*ptr;
	*(int*)(cptr+dimension+2)=args[0];
	*(int*)(cptr+dimension)=args[1];
	*(int*)(cptr+offset)=args[2];
	cptr[storage]=args[3];
	*(int*)(cptr+type)=args[4];
	cptr[ident]=args[5];
	sname=args[6]; ptr=cptr;
	while (an(*ptr++ = *sname++)) ;	/* copy name */
	}

static getlabel()	/* Return next avail internal label number */
	{return ++nxtlab;
	}

static printlabel(label) int label;	/* Print specified number as label */
	{outs("c"); outdec(label);
	}

static jlabel(label) int label;		/* Print label, colon and new line */
	{printlabel(label);col();nl();
	}

static an(c) int c;		/* Test if given character is alphanumeric */
	{return alpha(c) || isdigit(c);
	}

static ch()
	{return line[lptr];
	}

static cheq(c) int c;
	{return ch()==c;
	}
	
static nch()	/* return next character if there is one */
	{
	asm	{
		LD	HL,(qline)
		LD	DE,(qlptr)
		ADD	HL,DE
		LD	A,(HL)
		AND	A
		JR	Z,N1
		INC	HL
		LD	A,(HL)
	N1:	LD	L,A
		LD	H,0
		};
	}
	
static gch()	/* Get character and skip */
	{
	asm	{
		LD	HL,(qline)
		LD	DE,(qlptr)
		ADD	HL,DE
		LD	A,(HL)
		AND	A
		JR	Z,G1
		INC	DE
		LD	(qlptr),DE
	G1:	LD	L,A
		LD	H,0
		};
	}

static spaces()
	{
	asm {
		LD	DE,(qlptr)
		DEC	DE
	SC:	INC	DE
		LD	(qlptr),DE
		LD	HL,(qline)
		ADD	HL,DE
		LD	A,(HL)
		CP	' '
		JR	Z,SC
		CP	9
		JR	Z,SC
		LD	L,A
		LD	H,0
		};
	}

static kill()
	{
	asm	{
		XOR	A
		LD	HL,(qline)
		LD	(HL),A
		LD	H,A
		LD	L,A
		LD	(qlptr),HL
		};
	}

static blanks()
	{
	while (!spaces())
		{inline(); if (eof) break;
		preprocess();
		}
	return ch();
	}

static inline()
	{
	openin();
	if (eof) return;
	while (fgets(line,linemax,iinput? iinput: input)) 
		{++lineno;
		scan(line);
		if (*line) return;
		}
	if (iinput)
		{fclose(iinput);
		iinput = 0;
		lineno = saveline;
		fnstart = savestart;
		currfile = ffname;
		return;
		}
	fclose(input);
	input=0;
	}

static doctext()
	{
	if (ctext)
		{comment(); outln(line);
		}
	}
/*							*/
/*	Open an include file	*/
/*							*/
static include()
	{
	static char file[20];	/* must be static */
	static int i;
	if (iinput) error(7);
	else
		{i=0;
		if (cheq('"')) gch();
		while (i<19 && ch() && !cheq('"'))
			file[i++]=toupper(gch());
		file[i]=0;
		if (iinput=fopen(file,"i"))
			{saveline = lineno;
			savestart = fnstart;
			newfile(file);
			}
		else error(8);
		}
	kill();		/* clear line	*/
	}

static scan(s) char *s;
	{
	asm	{
		POP	BC
		POP	HL
		PUSH	HL
		PUSH	BC
		LD	B,0
		DEC	HL
	s1:	INC	HL
		INC	B
		LD	A,(HL)
		AND	A
		JR	Z,s3
		CP	13
		JR	Z,s2
		CP	10
		JR	NZ,s1
	s2:	LD	(HL),' '
		JR	s1
	s3:	DEC	B
		RET	Z
		DEC	HL
		LD	A,(HL)
		CP	9
		JR	Z,s4
		CP	' '
		RET	NZ
	s4:	LD	(HL),0
		JR	s3
		};
	}

static keepch(c) int c;
	{
	mline[mptr]=c;
	if (mptr<linemax) ++mptr;
	return c;
	}
	
static preprocess()
	{
	static char *preword[8]=
		{"", "else", "endif", "ifdef", "ifndef",
		"include", "define", "undef"
		};
	static replace,command,preptr;
	preptr=command=mptr=lptr=0;
	replace=1;
	if (spaces()=='#')
		{keepch(gch());
		if (isspace(ch())) keepch(' ');
		spaces();
		command=8;
		while (--command)
			if (aneq(line+lptr,preword[command])) break;
		if (!command) {error(76); kill(); return;}
		replace=(command==5);
		keepname(0);
		keepch(' ');
		preptr=mptr;
		spaces();
		}
	if (command || cmode)
		{doctext();
		while (ch())
			{if (isspace(ch()))
				{keepch(' '); spaces(); continue;
				}
			if (cheq('"'))
				{keepch(gch());
				while (ch()!='"' || backslash())
					{if (!nextline())
						{if (ch()) keepch(gch());
						else {error(34); break; }
						}
					}
				gch(); keepch('"');
				}
			else if (cheq('\''))
				{keepch(gch());
				while (ch()!='\'' || backslash())
				   {if (ch()) keepch(gch());
				   else {error(35); break;}
				   }
				gch(); keepch('\'');
				}
			else if (cheq('/') && nch()=='*')
				{lptr+=2;
				while (! (cheq('*') && nch()=='/'))
					{if (!gch()) inline(); 
					if (eof) break;
					}
				lptr+=2;
				}
			else if (keepname(replace)) ;
			else keepch(gch());
			replace=1;
			}
		mline[mptr]=0;
		if(mptr>=linemax) error(36);
		strcpy(line,mline);
		}
	lptr=preptr;
	if (command) docommand(command);
	if (locked) kill();
	}

static docommand(command) int command;
	{
	static clause=0;
	if (command<3)
		{if (!clause) error(84);					/* Missing #if(n)def */
		if (command==1) locked=!locked;						/* #else */
		else clause=locked=0;								/* #endif */
		}
	else if (!locked)
		{if (command==5) include();
		else if (alpha(spaces()))
			{if (command==6)								/* #define */
				{char sname[namesize];
				if (findmac(identifier(sname)))
					{cptr[name]=0; multidef();
					}
				addglb(sname,MACRO,0,0,macptr,0,0);
				spaces();
				do
					{if (!nextline()) if (!putmac(gch())) break;
					};
				if (macptr>=macmax) error(-38);
				}
			else if (command==7)							/* #undef */
				{if (findmac(line+lptr)) cptr[name]=0;
				else undefined();
				}
			else
				{locked=findmac(line+lptr)^command==3;		/* #if(n)def */
				if (clause) error(85);
				clause=1;
				}
			}
		else illname();
		}
	kill();
	}

static nextline()
	{
	if (cheq('\\'))
		{if (!(backslash() || nch()))
			{inline();
			doctext();
			return 1;
			}
		}
	return 0;
	}

static backslash()
	{
	static int k,slashes;
	k=lptr; slashes=0;
	while (k--)
		{if (line[k]=='\\') ++slashes;
		else break;
		}
	return slashes&1;
	}

static keepname(replace) int replace;
	{
	static int ptr,k;
	static char c,sname[namesize];
	if (!alpha(ch())) return 0;
	k=0;
	while (an(ch()))
		{if (k<namesize-1) sname[k++]=ch();
		gch();
		}
	sname[k]=0;
	ptr=mptr;
	if ((k=findmac(sname)) && replace)
		while (c=macq[k++]) keepch(c);
	else {k=0; while (c=sname[k++]) keepch(c);}
	mline[mptr]=0;
	if (replace && (k=token(ptr)))
		{mptr=ptr;
		keepch(k);
		mline[mptr]=0;
		}
	return 1;
	}

static findmac(sname) char *sname;
	{
	return
		(findglb(sname) && cptr[ident]==MACRO)?
		*(int*)(cptr+offset) :
		0;
	}

static putmac(c) int c;
	{
	macq[macptr]=c;
	if (macptr<macmax) ++macptr;
	return c;
	}

static identifier(sname) char *sname;
	{
	static char *sn;
	sn=sname; *sn=0;
	if (!alpha(blanks())) return 0;
	while (an(ch())) *sn++=gch();
	*sn=0;
	return sname;
	}

static token(ptr) int ptr;
	{
	static int loop;
	static char *position;
	loop=WORDS;
	position=mline+ptr;
	while (loop)
		if (aneq(position,word[--loop])) return loop+128;
	return 0;
	}

static skiptoken()
	{
	return blanks()>=128? gch(): 0;
	}

static istoken(tok) int tok;
	{
	return blank(tok)? gch(): 0;
	}

static outbyte(c) int c;			/* always to file */
	{
	if (output && c) {if (putc(c,output)<=0) writerror();}
	}

static outs(ptr) char *ptr;		 	/* always to file */
	{
	if (output) {if (!fputs(ptr,output)) writerror();}
	}

static bell()
	{putchar(7);}

static psp()
	{putchar(' ');}

static pnl()
	{putln("");}		/* always to screen */

static nl()
	{outs("\n");}		/* always to file */

static outline(ptr) char *ptr;
	{outtab(ptr); nl();}

static noutline(n,ptr) int n; char *ptr;
	{
	while (n--) outline(ptr);
	}

static outtab(ptr) char ptr[];
	{tab();	outs(ptr);}

static outdln(num) int num;
	{outdec(num); nl();}

static outln(str) char *str;
	{outs(str); nl();}

static tab()
	{outbyte('\t');}

static comment()
	{outbyte(';');}

static col()
	{outbyte(':');}

static quo()
	{outbyte('"');}

static com()
	{outbyte(',');}

static outdec(num) unsigned num;
	{
	outs(decimal(num));
	}

static putdec(num) unsigned num;
	{
	puts(decimal(num));
	}

static decimal(n) unsigned n;
	{
	static char *ptr,num[6]={};
	static unsigned int nbr;
	ptr=&num[4]; nbr=n;
	while (nbr>9)
		{*ptr--=nbr%10+'0'; nbr/=10;}
	*ptr=nbr+'0';
	return ptr;
	}

static endst()
	{return (blank(';') || eof || !ch());
	}

static ns()
	{if (!chmatch(';')) error(39);
	}

static comma()
	{return chmatch(',');
	}

static needcomma()
	{if (!comma()) error(40);
	}

static illclass()
	{
	if (class)
		{error(class+42-external);
		class=global;
		}
	}

static illstruc()
	{error(79);
	}

static undefined()
	{error(37);
	}

static illname()
	{error(45); junk();
	}

static multidef()
	{error(46);
	}

static needbrack(c) int c;
	{if (!chmatch(c)) error(49);
	}

static nc()
	{if (!chmatch(':')) error(50);
	}

static writerror()
	{error(-51);
	}

static error(num) int num;
	{
	static int k;
	if (currfile) {puts(currfile); puts(", ");}
	puts("\7\eALine ");
	putdec(lineno);
	if (currfn)
		{puts(" (@ "); puts(currfn);
		puts(" + ");
		putdec(lineno-fnstart);
		putchar(')');
		}
	puts(": ");
	lmessage(plus(num));
	k=0;
	do
		{if (k==lptr) puts("\12^\b\13");
		if (line[k]<128) putchar(line[k]);
		else puts(word[line[k]-128]);
		if (!line[k++]) break;
		};
	pnl(); pnl();
	++errcnt;
	if (num<0) abort();
	if (errstop)
		{pmessage(104); psp();
		k=toupper(getchar()); pnl();
		if (k=='N' || k==3) abort();
		if (k=='G') errstop=0;
		}
	}

static lmessage(msg) int msg;
	{
	pmessage(msg); pnl();
	}

static pmessage(msg) int msg;
	{
	puts(message(msg));
	putchar(5);				/* erase to end of line */
	}

static message(msg) int msg;
	{
	static char *fp,*m;
	static int num;
	if (fp=fopen("CC.MSG","i"))
		{
		while (fgets(m=msgbufadr,linemax,fp))
			{while (isspace(*m)) ++m;
			if (isdigit(*m))
				{num=0; while (isdigit(*m))
					num=num*10+*m++-'0';
				if (num==msg)
					{if (*m==':') ++m;
					if (isspace(*m)) ++m;
					scan(m);
					fclose(fp);
					return m;
					}
				}
			}
		fclose(fp);
		strcpy(msgbufadr,"[Message ");
		strcat(msgbufadr,decimal(msg));
		}
	else
		{strcpy(msgbufadr,"[File CC.MSG");
		}
	strcat(msgbufadr," not found]");
	return msgbufadr;
	}
		
static eq(s2) char *s2;
	{
	asm	{
		LD	HL,(qline)
		LD	DE,(qlptr)
		ADD	HL,DE
		EX	DE,HL
		POP	BC
		POP	HL
		PUSH	HL
		PUSH	BC
		LD	BC,0
	eq:	LD	A,(HL)
		AND	A
		JR	Z,retk
		LD	A,(DE)
		CP	(HL)
		INC	BC
		INC	DE
		INC	HL
		JR	Z,eq
		LD	HL,0
		RET
	retk:
		LD	H,B
		LD	L,C
		};
	}

static aneq(s1,s2) char *s1,*s2;
	{
	asm	{
		POP	BC
		POP	HL
		POP	DE
		PUSH	DE
		PUSH	HL
		PUSH	BC
		LD	BC,0
	aneq:
		LD	A,(DE)
		CALL	an
		JR	Z,tan
		LD	A,(DE)
		CP	(HL)
		JR	NZ,ret0
		INC	HL
		INC	DE
		INC	BC
		JR	aneq
	tan:
		LD	A,(HL)
		CALL	an
		LD	H,B
		LD	L,C
		RET	Z
	ret0:
		LD	HL,0
		RET
	an:	PUSH	HL
		PUSH	DE
		PUSH	BC
		LD	L,A
		LD	H,0
		PUSH	HL
		CALL	qan
		POP	BC
		LD	A,H
		OR	L
		POP	BC
		POP	DE
		POP	HL
		};
	}

static blank(c) int c;
	{return blanks()==c;
	}

static chmatch(c) int c;
	{return blank(c)? (++lptr,1): 0;
	}

static match(lit) char *lit;
	{
	asm	{
		CALL	qblanks
		POP	BC
		POP	HL
		PUSH	HL
		PUSH	BC
		PUSH	HL
		CALL	qeq
		POP	BC
		LD	A,H
		OR	L
		RET	Z
		LD	DE,(qlptr)
		ADD	HL,DE
		LD	(qlptr),HL
		LD	HL,1
		};
	}

static amatch(lit) char *lit;
	{
	asm	{
		CALL	qblanks
		LD	HL,(qline)
		LD	DE,(qlptr)
		ADD	HL,DE
		POP	BC
		POP	DE
		PUSH	DE
		PUSH	BC
		PUSH	HL
		PUSH	DE
		CALL	qaneq
		POP	BC
		POP	BC
		LD	A,H
		OR	L
		RET	Z
		LD	DE,(qlptr)
		ADD	HL,DE
		LD	(qlptr),HL
		LD	HL,1
		};
	}

#define LVAL 7

/*
** lval[orgtype] - original type, if double indirection or function-type
** lval[memtype] - type of indirect object to fetch, else 0 for static object
** lval[intype]  - type of pointer or array (for indirection), else 0
** lval[retype]  - type of value calculated
** lval[symaddr] - symbol table address, else 0 for constant
** lval[dimens]  - 2nd dimension if array
** lval[idd]     - if function, its id, else 0
*/

static expression()
	{
	int lval[LVAL];
	rvalue(lval,heir1(lval));
	return lval[retype];					  /* return type */
	}

static exprlist()
	{
	int typ;
	do typ=expression(); while (comma());
	return typ;
	}

static assignment(lval,kptr) int lval[]; int *kptr;
	{
	if (chmatch('='))
		{if (!locate(lval,kptr)) error(52);	/* need l-value */
		if (lval[memtype]) mainpush();
		return 1;
		}
	return 0;
	}

static heir1(lval) int lval[];
	{
	int k=heir2a(lval);
	if (assignment(lval,&k))
		{force(lval[retype],expression());
		store(lval);
		return 0;
		}
	return k;
	}

static heir2a(lval) int lval[];
	{
	int k=heir2b(lval);
	if (chmatch('?'))
		{int lval2[LVAL],
		lab0=getlabel(),
		lab1=getlabel();
		rvalue(lval,k);
		testjump(lab0,lval[retype]);
		rvalue(lval,heir1(lval));
		jump(lab1); nc();
		jlabel(lab0);
		rvalue(lval2,heir1(lval2));
		if (bigtype(lval[retype]) || bigtype(lval2[retype]))
			{int lab2=getlabel();
			lval2[retype]=cond(lval[retype],lval2[retype]);
			jump(lab2);
			jlabel(lab1);
			lval[retype]=cond(lval2[retype],lval[retype]);
			jlabel(lab2);
			}
		else
			{if (!lval2[intype]) lval[intype]=0;
			lval[retype] =
				(lval[retype]==UINT || lval2[retype]==UINT)? UINT
				: INT;
			jlabel(lab1);
			}
		return 0;
		}
	return k;
	}

static cond(t1,t2) int t1,t2;
	{
	if (isdouble(t1))
		return force(DOUBLE,t2);
	else if (islong(t1) && !isdouble(t2))
		return force(LONG,t2);
	return t2;
	}
	
static heir2b(lval) int lval[];
	{
	int k=heir2c(lval);
	blanks();
	if (eq("||"))
		{int lval2[LVAL];
		rvalue(lval,k);
		while (match("||"))
			{testbig(lval[retype]);
			mainpush();
			rvalue(lval2,heir2c(lval2));
			testbig(lval2[retype]);
			popcall("CCLOR");
			lval[retype]=INT;
			}
		return 0;
		}
	return k;
	}

static heir2c(lval) int lval[];
	{
	int k=heir2d(lval);
	blanks();
	if (eq("&&"))
		{int lval2[LVAL];
		rvalue(lval,k);
		while (match("&&"))
			{testbig(lval[retype]);
			mainpush();
			rvalue(lval2,heir2d(lval2));
			testbig(lval2[retype]);
			popcall("CCLAND");
			lval[retype]=INT;
			}
		return 0;
		}
	return k;
	}

static heir2d(lval) int lval[];
	{
	int k=heir3(lval);
	if (blank('|') && !eq("||"))
		{int lval2[LVAL];
		rvalue(lval,k);
		while (!eq("||"))
			{if (!chmatch('|')) break;
			tpush(lval);
			rvalue(lval2,heir3(lval2));
			intcheck(lval,lval2);
			if (widen(lval,lval2)) dpopcall("LOR");
			else popcall("CCOR");
			}
		return 0;
		}
	return k;
	}

static heir3(lval) int lval[];
	{
	int k=heir4(lval);
	if (blank('^'))
		{int lval2[LVAL];
		rvalue(lval,k);
		while (chmatch('^'))
			{tpush(lval);
			rvalue(lval2,heir4(lval2));
			intcheck(lval,lval2);
			if (widen(lval,lval2)) dpopcall("LXOR");
			else popcall("CCXOR");
			}
		return 0;
		}
	return k;
	}

static heir4(lval) int lval[];
	{
	int k=heir5(lval);
	if (blank('&') && !eq("&&"))
		{int lval2[LVAL];
		rvalue(lval,k);
		while (!eq("&&"))
			{if (!chmatch('&')) break;
			tpush(lval);
			rvalue(lval2,heir5(lval2));
			intcheck(lval,lval2);
			if (widen(lval,lval2)) dpopcall("LAND");
			else popcall("CCAND");
			}
		return 0;
		}
	return k;
	}

static heir5(lval) int lval[];
	{
	int k=heir6(lval);
	blanks();
	if (eq("==") || eq("!="))
		{rvalue(lval,k);
		do
			{if (match("==")) equal(lval,"DEQ","LEQ","CCEQ");
			else if (match("!=")) equal(lval,"DNE","LNE","CCNE");
			else break;
			};
		return 0;
		}
	return k;
	}

static equal(lval,df,lf,zf) int lval[]; char *df,*lf,*zf;
	{
	int lval2[LVAL];
	tpush(lval);
	rvalue(lval2,heir6(lval2));
	if (widen(lval,lval2))
		dpopcall(isdouble(lval[retype])? df: lf);
	else popcall(zf);
	lval[retype]=INT;
	}

static heir6(lval) int lval[];
	{
	int k=heir7(lval);
	if ((blank('<')||blank('>')||eq("<=")||eq(">="))&&!(eq(">>")||eq("<<")))
		{rvalue(lval,k);
		do
			{if (match("<=")) compare(lval,"DLE","LLE","CCLE","CCULE");
			else if (match(">=")) compare(lval,"DGE","LGE","CCGE","CCUGE");
			else if (blank('<') && !eq("<<")) 
				{gch();
				compare(lval,"DLT","LLT","CCLT","CCULT");
				}
			else if (blank('>') && !eq(">>"))
				{gch();
				compare(lval,"DGT","LGT","CCGT","CCUGT");
				}
			else break;
			};
		return 0;
		}
	return k;
	}

static compare(lval,df,lf,zf,uf) int lval[]; char *df,*lf,*zf,*uf;
	{
	int lval2[LVAL];
	tpush(lval);
	rvalue(lval2,heir7(lval2));
	if (widen(lval,lval2))
		dpopcall(isdouble(lval[retype])? df: lf);
	else if (dblsigned(lval,lval2)) popcall(zf);
	else popcall(uf);
	lval[retype]=INT;
	}

static heir7(lval) int lval[];
	{
	int op,k=heir8(lval);
	if (op=shiftop())
		{int lval2[LVAL];
		int a=assignment(lval,&k);
		rvalue(lval,k);
		do
			{tpush(lval);
			rvalue(lval2,a? heir1(lval2): heir8(lval2));
			intcheck(lval,lval2);
			force(INT,lval2[retype]);
			if (op=='>')
				{if (islong(lval[retype])) dpopcall("LRSH");
				else
					{zpop();
					if (signed(lval)) asr(); else lsr();
					}
				}
			else
				{if (islong(lval[retype])) dpopcall("LLSH");
				else asl();
				}
			} while (op=shiftop());
		if (a) store(lval);
		return 0;
		}
	return k;
	}

static shiftop()
	{
	return match(">>")? '>': match("<<")? '<': 0;
	}

static heir8(lval) int lval[];
	{
	int num1(),op,k=heir9(lval);
	if (op=addop())
		{int lval2[LVAL];
		int f,t,a=assignment(lval,&k);
		rvalue(lval,k);
		do
			{if (f=bigtype(t=lval[retype])) dpush();
			else if (number(&k,num1,(a || op=='+')?1:-1))
				{if (lval[intype])
					k*=(unsigned)typesize(lval[intype])*second(lval);
				add((a && op=='-')? -k : k);
				lval2[retype]=INT; zerolval(lval2);
				}
			else {mainpush(); f=1;}
			if (f)
				{rvalue(lval2,a? heir1(lval2) : heir9(lval2));
				if (dbltest(lval,lval2)) scale(lval);
				if (op=='+')
					{if (widen(lval,lval2))
						dpopcall(islong(lval[retype])? "LADD": "DADD");
					else
					    {if (dbltest(lval2,lval))
							{swapstk(); scale(lval2);
							}
					    zpop(); zadd();
						dblsigned(lval,lval2);
					    }
					}
				else
					{if (widen(lval,lval2))
						dpopcall(islong(lval[retype])? "LSUB": "DSUB");
					else
						{if (dbltest(lval2,lval))
						    {swapstk(); scale(lval2);
						    swapstk();
						    }
						zsub();
						if ((k=typesize(lval[intype]))==typesize(lval2[intype]) && k)
							{if ((k*=(unsigned)second(lval)) == 2)
								{outline("SRA\tH\n\tRR\tL"); /*  div by 2  */
								}
							else if (k!=1)
								{swap(); mainload(k); div();
								}
							}
						dblsigned(lval,lval2);
						}
					}
				}
			if (a) {lval[retype]=force(t,lval[retype]); store(lval);}
			else result(lval,lval2);
			}
		while (op=addop());
		return 0;
		}
	return k;	
	}

static addop()
	{
	return chmatch('+')? '+': chmatch('-')? '-': 0;
	}

static heir9(lval) int lval[];
	{
	int k,op;
	if (number(&k,num1,1))
		{lval[retype]=INT; mainload(k);
		return zerolval(lval);
		}
	k=heir10(lval);
	if (op=mulop())
		{int lval2[LVAL];
		int t,a=assignment(lval,&k);
		rvalue(lval,k);
		do
			{if (bigtype(t=lval[retype])) dpush();
			else mainpush();
			rvalue(lval2,a? heir1(lval2): heir10(lval2));
			if (op=='*')
				{if (widen(lval,lval2))
					dpopcall(islong(lval[retype])? "LMUL" :"DMUL");
				else
					{if (dblsigned(lval,lval2)) popcall("CCMUL"); else umul();}
				}
			else if (op=='/')
				{if(widen(lval,lval2))
					dpopcall(islong(lval[retype])? "LDIV": "DDIV");
				else
					{zpop(); if (dblsigned(lval,lval2)) div(); else udiv();}
				}
			else
				{intcheck(lval,lval2);
				if (widen(lval,lval2)) dpopcall("LMOD");
				else
					{zpop();
					if (dblsigned(lval,lval2)) div(); else udiv();
					swap();							/* rest comes in DE */
					}
				}
			if (a) {lval[retype]=force(t,lval[retype]); store(lval);}
			}
		while (op=mulop());
		return 0;
		}
	return k;
	}

static mulop()
	{
	return chmatch('*')? '*': chmatch('/')? '/': chmatch('%')? '%': 0;
	}

static heir10(lval) int lval[];
	{
	int num2(),k;
	if (number(&k,num2,1))
		{lval[retype]=INT; mainload(k);
		return zerolval(lval);
		}
	return heira(lval);
	}

static heira(lval) int lval[];
	{
	int f=0;
	if (match("++")) ++f;
	else if (match("--")) --f;
	if (f) return affix(heira(lval),lval,f,0);
	else if (chmatch('!'))
		{rvalue(lval,heira(lval));
		select(lval[retype],"DNOT","LNOT","CCNOT");
		lval[retype]=INT; 
		}
	else if (chmatch('-'))
		{rvalue(lval,heira(lval));
		select(lval[retype],"MINUSFA","LNEG","CCNEG");
		}
	else if (chmatch('*'))
		{f=1;
		rvalue(lval,heira(lval));
		if (lval[intype])
			{if (lval[idd]=spec(lval[idd]))
				lval[symaddr]=lval[intype]=f=0;
			else if (f=!lval[dimens])
				{lval[retype]=lval[memtype]=lval[intype];
				lval[intype]=lval[orgtype]; lval[orgtype]=0;
				}
			else lval[dimens]=0;
			}
		else error(53);
		return f; 			/* dereferenced pointer is lvalue if not 2nd dim */
		}
	else if (chmatch('&'))
		{
		if (address(lval,heira(lval),0))
			{
			if (lval[idd]) {lval[intype]=lval[idd]=0;}
			lval[orgtype]=lval[intype];
			lval[intype]=lval[retype]; lval[retype]=UINT;
			lval[memtype]=UINT;
			}
		else error(54);
		return 0;
		}
	else if (chmatch('~'))
		{rvalue(lval,heira(lval));
		select(checkint(lval[retype]),0,"LCOM","CCCOM");
		}
	else 
		{int k=heirb(lval,1);				/* 1 = call primary */
		if (match("++")) ++f;
		else if (match("--")) --f;
		if (f)
			{affix(k,lval,f,1);
			k=heirb(lval,0);
			}
		return k;
		}
	return zerolval(lval);
	}

affix(k,lval,size,postfix) int k; int lval[]; int size,postfix;
	{
	if (locate(lval,&k))
		{
		if (lval[memtype]) mainpush();
		rvalue(lval,k);
		if (islong(checkint(lval[retype])))
			{library(size>0? "LINC": "LDEC");
			store(lval);
			if (postfix) library(size>0? "LDEC": "LINC");
			}
		else
			{if (lval[intype]) size*=(unsigned)typesize(lval[intype]);
			add(size*=(unsigned)second(lval));
			store(lval);
			if (postfix) add(-size);
			}
		}
	else error(52);
	return 0;
	}

static select(typ,ds,ls,is) int typ; char *ds,*ls,*is;
	{
	library( isdouble(typ)? ds
		: islong(typ)? ls
		: is );
	}

static add(size) int size;
	{
	static sz;
	if ((sz=size)==32768 || sz<-3 || sz>3)
		{zload(sz); zadd();
		}
	else if (sz<0) while (sz++) dec();
	else if (sz>0) while (sz--) inc();
	}

static zerolval(lval) int lval[];
	{
	return
		lval[orgtype] =
		lval[memtype] =
		lval[intype] =
		lval[symaddr] =
		lval[dimens] =
		lval[idd] = 0;
	}

static second(lval) int lval[];
	{
	static unsigned d;
	d=lval[dimens];
	return (!d || null(d))? 1 : d;
	}

/*
** lval[orgtype] - original type, if multi-indirection or function-type
** lval[memtype] - type of stacked object to fetch, else 0 for static object
** lval[intype]  - type of pointer or array (for indirection), else 0
** lval[retype]  - type of value calculated
** lval[symaddr] - symbol table address, else 0 for constant
** lval[dimens]  - 2nd dimension
** lval[idd]     - if function, its id, else 0
*/

static heirb(lval,k) int lval[]; int k;
	{
	char *ptr;
	int flag=1;
	if (k) k=primary(lval,0);	/* 0 = don't look for struct components */
	ptr=lval[symaddr];
	do	{
		if (chmatch('('))
			{unsigned id,typ,dim;
			rvalue(lval,k);
			if (id=spec(lval[idd]))
				{typ=lval[orgtype];
				dim=lval[dimens];
				zerolval(lval);			/* kill old values, esp. id in [idd] */
				lval[dimens]=dim;
				if (id==function) lval[retype]=typ;
				else 
					{lval[retype]=UINT;
					if (id==pfunc) lval[intype]=typ;
					else 
						{lval[intype]=UINT; lval[orgtype]=typ;
						}
					}
				}
			else {error(56); zerolval(lval);}
			callfunc((ptr && ptr<ENDGLB && !k)? ptr : 0);
			ptr=k=0;
			}
		else if (chmatch('['))
			{unsigned typ,val,dim;
			if (null(dim=lval[dimens])) dim=1;
			if ((typ=typesize(lval[intype])) && !lval[idd])
				{
				if (subscript(&val))
					{val *= (dim)? typ*dim: typ;
					if (k<0) address(lval,k,val);
					else
						{rvalue(lval,k);
						add(val);
						}
					}
				else
					{rvalue(lval,k);
					mainpush(); force(UINT,expression());
					multiply(typ * (dim? dim: 1));
					zpop(); zadd();
					}
				lval[memtype]=lval[intype];
				lval[dimens]=0;
				if (k=!dim)
					{lval[retype]=lval[intype];
					lval[intype]=lval[orgtype]; lval[orgtype]=0;
					}
				}
			else {error(55); junk();}
			needbrack(']');
			}
		else if (blank('.') || eq("->"))
			{int lval2[LVAL],k2;
			char *ptr2;
			if (chmatch('.'))
				{if (lval[retype]>0)
					{if (lval[intype]<0) error(82);
					else error(78);
					}
				}
			else
				{match("->");
				if (lval[retype]<=0) error(83);
				else
					{if (lval[intype]>=0) error(78);
					k=rvalue(lval,k);
					}
				}
			k2=primary(lval2,1);	/* 1 = need structure components */
			if (ptr2=lval2[symaddr])
				{if (plus(k)>1) address(lval,k,*(int*)(ptr2+offset));
				else add(*(int*)(ptr2+offset));
				}
			else illname();
			k=k2; ptr=ptr2;
			intcopy(lval,lval2,LVAL);
			}
		else break;
		flag=0;
		};
	if (flag && ptr)
	 	{if (isfunc(ptr[ident]) && !k)
			{loadsym(ptr,0);
			zerolval(lval);		/* global function */
			}
		}
	return k;
	}

static primary(lval,struc) int lval[]; int struc;
	{
	char *ptr,sname[namesize];
	int id,typ,num,k;
	zerolval(lval);
	if (chmatch('('))
		{int save[SAVENUM];
		intcopy(save,elem,SAVENUM);
		if (typename(0,&id,&typ))			/* cast operation */
			{
			id=declare(0,id,&typ);
			needbrack(')');
			rvalue(lval,heira(lval));
			zerolval(lval);
			lval[dimens]=elem[1];
			if (isvar(id)) lval[retype]=force2(typ,lval[retype]);
			else
				{lval[retype]=force(UINT,lval[retype]);
				if (id==pointer || id==array) lval[intype]=typ;
				else 
					{lval[orgtype]=typ;
					if (isfunc(spec(id))) lval[idd]=id;
					if (!isfunc(id)) lval[intype]=UINT;
					}
				}
			k=0;
			}
		else {do k=heir1(lval); while (comma()); needbrack(')');}
		intcopy(elem,save,SAVENUM);
		return k;
		}
	if (identifier(sname))
		{
		ptr = struc? findstruc(sname): findloc(sname,ENDGLB);
		if (ptr && !(isstruc(id=ptr[ident]) || ismacro(ptr)))
			{				 /* no struct description, no macro, please! */
			if (ptr[storage]==statik)
				k=getstatic(lval,ptr);
			else
				{lval[memtype]=*(int*)(ptr+type);
				lval[retype]=UINT; k=2;		/* assume lvalue */
				lval[dimens]=*(int*)(ptr+dimension+2);
				if (isvar(id)) lval[retype]=*(int*)(ptr+type);
				else if (id==array) {lval[intype]=*(int*)(ptr+type); k=-2;}
				else
					{lval[memtype]=UINT;
					if (id==pointer) lval[intype]=*(int*)(ptr+type);
					else
						{lval[orgtype]=*(int*)(ptr+type);
						if (isfunc(spec(id))) lval[idd]=id;
						if (!isfunc(id))
							{lval[intype]=UINT; 
							if (id==parray) k=-2;	/* lvalue, if ppointer */
							}
						}
					}		
				lval[symaddr]=ptr;
				if (struc) k = (k==2);
				}
			return k;
			}
		if (!struc && (ptr=findglb(sname)) && !ismacro(ptr))
			{
			if (isfunc(id=ptr[ident]))
				{lval[symaddr]=ptr;
				lval[dimens]=*(int*)(ptr+dimension+2);
				lval[idd]=id;
				lval[retype]=UINT; lval[orgtype]=*(int*)(ptr+type);
				k=0;
				}
			else k=getstatic(lval,ptr);
			}
		else
			{if (!blank('(')) undefined();
			lval[symaddr]=addglb(sname,function,INT,global,0,0,0);
			lval[idd]=function; lval[retype]=UINT;
			lval[orgtype]=INT; k=0;
			}
		return k;
		}
	if (!constant(&num,&lval[retype])) {error(59); junk();}
	return 0;
	}

static getstatic(lval,ptr) int lval[]; char *ptr;
	{
	static int id,typ;
	typ=*(int*)(ptr+type);
	id=ptr[ident];
	lval[symaddr]=ptr;
	lval[dimens]=*(int*)(ptr+dimension+2);
	lval[retype]=UINT;
	if (isarray(id))
		{lval[memtype]=lval[intype]= (id==parray)?
			((lval[orgtype]=typ),UINT) : typ;
		return -3;
		}
	if (id==pointer) lval[intype]=typ;
	else if (id==ppoint || isfunc(spec(id)))
		{lval[intype]=UINT; lval[orgtype]=typ;
		if (isfunc(spec(id))) lval[idd]=id;
		}
	else lval[retype]=typ;
	return 3;
	}

static structure(structyp) int structyp;
	{
	char sname[namesize];
	int given,id,typ,size=0,off=0,sz;
	int elem2=elem[2],elem3=elem[3];
	needbrack('{');
	do	{
		link=0;
		if (!typename(0,&given,&typ)) {error(73); junk();}
		else do
			{
			if (isfunc(id=decl0(sname,given,&typ)))
				{error(57); continue;
				}
			if (*sname)
				{char *curr=findstruc(sname);
				if (curr)
					{if (id!=curr[ident]
						|| *(int*)(curr+type)!=typ
						|| *(int*)(curr+offset)!=off
						|| *(int*)(curr+dimension+2)!=elem[1]) error(74);
					}
				else curr=addstruc(sname,id,typ,automatic,off,elem[0],elem[1]);
				if (link) addlink(link,curr);
				}
			sz=getsize(id,typ);
			if (structyp==STRUCT) off=(size+=sz);
			else if (sz>size) size=sz;			/* union */
			if (!*sname) break;
			} while (comma());
		ns();
		} while (!chmatch('}'));
	elem[2]=elem2;
	elem[3]=elem3;
	return size;
	}

static findlink(ptr) char *ptr;
	{
	int k=linkptr;
	while (k)
		{if (linklist[--k][0]==ptr) return ptr;
		}
	return 0;
	}
	
static addlink(ptr,comp) char *ptr,*comp;
	{
	if (linkptr<linksize)
		{linklist[linkptr][0]=ptr;
		linklist[linkptr][1]=comp;
		++linkptr;
		}
	else error(75);
	}

static declare(sname,id,typ) char *sname; int id,*typ;
	{
	link=0;
	++linklevel;
	id=decl0(sname,id,typ);
	if (!--linklevel)			/* ensure only one final linking */
		{
		while (linkptr)
			if (linklist[--linkptr][1])
				{*(int*)(linklist[linkptr][1]+type) =
				-*(int*)(linklist[linkptr][0]+type);
				}
		}
	return id;
	}

static decl0(sname,id,typ) char *sname; int id,*typ;
	{
	int st=isstruc(*typ);
	if (st)
		{int needstruc=1,size=0;
		char sn[namesize],*ptr=0;
		if (identifier(sn))
			{if (ptr=findstruc(sn))
				{needstruc=0;
				if (blank('{') || ptr[ident]!=*typ) multidef();
				link=findlink(ptr);
				}
			else addlink(ptr=addstruc(sn,*typ,0,global,0,0,0),0);
			}
		if (blank('{') || needstruc)
			{size=structure(*typ);
			if (ptr) *(int*)(ptr+type)=size;
			link=0;
			}
		else if (ptr) size=*(int*)(ptr+type);
		*typ=-size;
		}
	fndef=0;
	if (need=sname) *sname=0;
	elem[0]=elem[2];
	elem[1]=elem[3];
	id=decl1(&sname,id);
	if (need)
		{if (sname)
			{link=0;
			if (st) *typ=0;
			else {error(60); junk();} /* missing identifier */
			}
		else if (link && (isvar(id) || id==array)) error(80); /* recursive */
		}
	return id;
	}

static decl1(sname,id) char **sname; int id;
	{
	if (chmatch('*')) return turnpoint(decl1(sname,id));
	if (chmatch('('))
		{if (chmatch(')')) id=turnfunc(id);
		else
			{id=decl1(sname,id);
			needbrack(')');
			}
		}
	return decl2(sname,id);
	}

static decl2(sname,id) char **sname; int id;
	{
	int k,j=elem[1]? 2: elem[0]? 1: 0;
	getname(sname);
	while (chmatch('['))
		{
		if (j>1) {error(77); j=1;}
		elem[j]=(k=needsub())? k : -1;
		if (isfunc(spec(id))) error(55);	/* subscript? */
		else if (isvar(id)) id=array;
		else if (ispointer(id))
			{elem[1]=elem[0];
			elem[0]=-1; ++j;
			if (id==ppoint) error(71);
			}
		++j;
		}
	getname(sname);
	if (chmatch('('))
		{if (!(*sname || ispointer(id)))
			{if (fndef=fndefine()) return turnfunc(id);
			}
		id=turnfunc(id);
		needbrack(')');
		getname(sname);
		}
	return id;
	}

static getname(sname) char **sname;
	{
	if (*sname) if (identifier(*sname)) *sname=0;
	}

static turnfunc(id) int id;
	{
	if (spec(id)==pointer)
		{if (id==ppoint || elem[0]) error(71);
		return function+OFFSET;
		}
	if (!isvar(id)) error(61);
	return function;
	}

static turnpoint(id) int id;
	{
	switch (id)
		{case array:			return parray;
		case variable:			return pointer;
		case function:			return pfunc;
		case pfunc:				return ppfunc;
		case pointer:			return ppoint;
		case function+OFFSET:	return pfunc+OFFSET;
		case pfunc+OFFSET:		return ppfunc+OFFSET;
		}
	error(62);
	return id;
	}

/* 				GET REQUIRED ARRAY SIZE					*/
/* invoked when declared variable is followed by "["	*/

static needsub()
	{
	int num;
	if (chmatch(']')) return 0;				/* null size */
	if (!subscript(&num))					/* go after a number */
		{error(63);							/* it isn't */
		num=1;								/* so force one */
		}
	else if (!num)
		{error(64);
		num=1;
		}
	needbrack(']');	
	return num;
	}

static fndefine()
	{
	static int ptr,fn;
	fn=0;
	if (blanks() && need && !currfn && class!=typdef) 
		{
		if (!cheq(')')) return 1;
		ptr=lptr;
		gch(); spaces();
		fn = !(cheq(';') || cheq(',') || cheq('=') || cheq(')'));
		lptr=ptr; 
		}
	return fn;
	}

static typename(class,id,typ) int class,*id,*typ;
	{
	static int unsign,ntyp;
	*id = ntyp = 0;
	elem[2]=elem[3]=0;
	unsign=istoken(stunsigned);
	switch (blanks())
		{
		case stdouble:
		case stfloat:	skiptoken(); ntyp=DOUBLE; break;
		case stshort:	skiptoken(); istoken(stint); ntyp=INT; break;
		case stlong:	skiptoken(); istoken(stint); ntyp=LONG; break;
		case stint:		skiptoken(); ntyp=INT; break;
		case stchar:	skiptoken(); ntyp=CHAR; break;
		case ststruct:	skiptoken(); ntyp=STRUCT; break;
		case stunion:	skiptoken(); ntyp=UNION; break;
		}
	if (unsign)
		{if (bigtype(ntyp) || isstruc(ntyp)) error(65);
		else if (!ntyp) ntyp=UINT;
		else ntyp+=OFFSET;
		}
	if (!(*typ=ntyp))
		{char sname[namesize],*ptr;
		int l=(blanks(),lptr);
		if (identifier(sname))
			if ((ptr=findsym(sname)) && ptr[storage]==typdef)
				{elem[2]=*(int*)(ptr+dimension);
				elem[3]=*(int*)(ptr+dimension+2);
				*id=ptr[ident];
				return *typ=*(int*)(ptr+type);
				}
		lptr=l;
		if (class || !currfn) ntyp=*typ=INT;
		}
	if (ntyp) *id=variable;
	return ntyp;
	}

static isextern()
	{return spec(class)==external;
	}

static ischar(typ) int typ;
	{return spec(typ)==CHAR;
	}

static isint(typ) int typ;
	{return spec(typ)==INT;
	}

static isdouble(typ) int typ;
	{return typ==DOUBLE;
	}

static islong(typ) int typ;
	{return typ==LONG;
	}

static bigtype(typ) int typ;
	{return isdouble(spec(typ));
	}

static isstruc(id) int id;
	{return spec(id)==STRUCT;
	}

static ismacro(ptr) char *ptr;
	{
	return ptr[ident]==MACRO || ptr[storage]==typdef;
	}

static typesize(typ) int typ;
	{
	if (typ>0) return typ&(OFFSET-1);
	return -typ;
	}

static spec(id) int id;
	{return id&(-1-OFFSET);
	}

static isvar(id) int id;
	{return id==variable;
	}

static ispointer(id) int id;
	{
	if (spec(id)==pointer) return 1;
	return isfunc(spec(id)) && !isfunc(id);
	}

static isfunc(id) int id;
	{return id==function || ispfunc(id);
	}

static ispfunc(id) int id;
	{return id==pfunc || id==ppfunc;
	}

static isarray(id) int id;
	{return spec(id)==array;
	}

/* Complains if an operand isn't int */
static intcheck(v1,v2) int v1[],v2[];
	{
	if (check(v1[retype]) || check(v2[retype])) error(66);
	}

static checkint(typ) int typ;
	{
	if (check(typ)) error(67);
	return typ;
	}

static check(typ) int typ;
	{
	return isdouble(typ) || typ<=0;
	}

/* Forces result, having type t2, to have type t1 */
static force(t1,t2) int t1,t2;
	{
	if (isdouble(t1)) 
		{if (islong(t2)) library("LTOD");
		else if (t2==UINT) library("QUFLOAT");
		else if (!isdouble(t2)) library("QFLOAT");
		}
	else if (islong(t1))
		{if (isdouble(t2)) library("DTOL");
		else if (t2==UINT) library("UTOL");
		else if (!islong(t2)) library("ITOL");
		}
	else if (isdouble(t2))
		{if (t1==UINT) library("QUIFIX");
		else library("QIFIX");
		}
	else if (islong(t2))
		{if (t1==UINT) library("LTOU");
		else library("LTOI");
		}
	if ((t1<=0 || t2<=0) && t1!=t2) error(86);
	return t1;
	}

static force2(t1,t2) int t1,t2;
	{
	if (t1==UCHAR && (t2==CHAR || isint(t2))) outline("LD\tH,0");
	else if ((t1==CHAR || t1==INT) && t2==UCHAR)
		{outline("LD\tA,L"); extend();
		}
	else force(t1,t2);
	return t1;
	}

/* If only one operand is DOUBLE, converts the other one to */
/* DOUBLE.  Returns 1 if result will be DOUBLE.	jrvz 10/9/82 */

static widen(lval1,lval2) int lval1[],lval2[];
	{
	if (bigtype(lval2[retype]))
		{if (!bigtype(lval1[retype]))
			{dpush2();			    /* push 2nd operand UNDER 1st */
			mainpop();
			force(lval2[retype],lval1[retype]);
			dswap();
			lval1[retype]=lval2[retype];		 /* type of result */
			}
		else if (islong(lval1[retype]) && isdouble(lval2[retype]))
			{dswap();
			force(lval1[retype]=DOUBLE,LONG);
			dswap();
			}
		else force(lval1[retype],lval2[retype]);
		}
	else if (bigtype(lval1[retype]))
		{force(lval1[retype],lval2[retype]);
		}
	else return 0;
	return 1;
	}

static dblsigned(lval,lval2) int lval[],lval2[];
	{
	if (signed(lval) && signed(lval2)) return 1;
	if (!bigtype(lval[retype])) lval[retype]=UINT;
	return 0;
	}

static signed(lval) int lval[];
	{
	return lval[intype]? 0 : lval[retype]!=UINT;
	}

/* true if lval1 -> int pointer or int array and lval2 not ptr or array */
static dbltest(lval1,lval2) int lval1[], lval2[];
	{
	if (lval1[intype] && !lval2[intype] && !bigtype(lval2[retype]))
		return !ischar(lval1[intype]) || second(lval1)!=1;
	return 0;
	}

static test(label) int label;
	{
	needbrack('(');
	testjump(label,expression());
	needbrack(')');
	}

/* Test the primary/FP register and jump if false to label */
static testjump(label,typ) int label,typ;
	{
	if (!testbig(typ))
		outline("LD\tA,H\n\tOR\tL");
	outtab("JP\tZ,");
	printlabel(label);
	nl();
	}

static testbig(typ) int typ;
	{
	if (bigtype(typ))
		{select(typ,"TESTFA","LTEST",0);
		return 1;
		}
	return 0;
	}

static constant(val,typ) int *val,*typ;
	{
	static ftyp;
	if (ftyp=fnumber(val))
		{*typ=ftyp;
		loadsym(0,*val); dload();
		}
	else
		{*typ=INT;
		if (integer(val)) mainload(*val);
		else if (quoted(val)) {*typ=UINT; loadsym(0,*val);}
		else return 0;
		}
	return 1;
	}

static fnumber(val) int *val;
	{
	double atol();
	static double *dp,		/* used to store the result */
	sum,					/* the partial result */
	scale;					/* scale factor for next digit */
	static char *start,		/* copy of pointer to starting point */
	*s;						/* points into source code */
	static int li,			/* flag for long int */
	k,						/* flag and mask */
	minus;					/* negative if number is negative */
	blanks();
	s=line+lptr;				/* save starting point */
	if (minus=(*s=='-')) ++s;
	start=s;
	while (isdigit(*s)) ++s;
	if (li=(toupper(*s)=='L'))
		{sum=atol(start-minus);
		lptr=s-line+1;
		}
	else
		{if (*s++!='.') return 0;
		while (isdigit(*s)) ++s;
		lptr=(s--)-line;
		sum=0.; scale=1.;
		while (*s!='.')
			sum=(sum+(*(s--)-'0'))/10.;
		while (--s>=start)
			{sum+=scale*(*s-'0');
			scale*=10.;
			}
		if (toupper(spaces())=='E')
			{static int neg,expon;
			gch();
			if (!exponent(&expon))
				{error(68); expon=0;
				}
			if (neg=(expon<0)) expon=-expon;
			if (expon>38)
				{error(69); expon=0;
				}
			k=32;
			scale=1.;
			while (k)
				{scale*=scale;
				if (k&expon) scale*=10.;
				k>>=1;
				}
			if (neg) sum/=scale;
			else sum*=scale;
			}
		if (minus) sum=-sum;
		}
	dp=litq+litptr+3;
	*val=addlit(0,DOUBLE,abs);
	*dp=sum;										/* store result */
	return li? LONG: DOUBLE;						/* report success */
	}

static double atol(str) char *str;
	{
	asm {
		LD	HL,NULL
		CALL	DLOAD
		POP	BC
		POP	HL
		PUSH	HL
		PUSH	BC
		DEC	HL
	SKIP:
		INC	HL
		LD	A,(HL)
		CP	' '
		JR	Z,SKIP
		CP	9
		JR	Z,SKIP
		SUB	'-'
		LD	(MINUS),A
		JR	NZ,CONT
		INC	HL
	CONT:
		LD	A,(HL)
		SUB	'0'
		JR	C,FIN
		CP	10
		JR	NC,FIN
		PUSH	HL
		CALL	MUL10
		POP	HL
		INC	HL
		JR	CONT
	FIN:
		LD	A,(MINUS)
		AND	A
		RET	NZ
		LD	H,A
		LD	L,A
		LD	DE,(FA)
		SBC	HL,DE
		LD	(FA),HL
		LD	H,A
		LD	L,A
		LD	DE,(FA+2)
		SBC	HL,DE
		LD	(FA+2),HL
		RET
	MUL10:
		CALL	MUL2
		EXX
		CALL	MUL2
		CALL	MUL2
		EXX
		CALL	DOADD
		LD	C,A
		LD	B,0
		LD	E,B
		LD	D,E	
		JR	DOADD
	MUL2:
		LD	BC,(FA)
		LD	DE,(FA+2)
	DOADD:
		LD	HL,(FA)
		ADD	HL,BC
		LD	(FA),HL
		LD	B,H
		LD	C,L
		LD	HL,(FA+2)
		ADC	HL,DE
		LD	(FA+2),HL
		EX	DE,HL
		RET
	NULL:	DB	0,0,0,0,0,0
	MINUS:	DB	0
		};
	}

static integer(val) int *val;
	{
	blanks();
	if (hnumber(val)) ;
	else if (exponent(val)) ;
	else if (primed(val)) ;
	else if (sizeo(val)) ;
	else return 0;
	return 1;
	}

static exponent(val) int *val;
	{
	int sign = (chmatch('-'))? (blanks(),-1) : 1;
	return digits(val)? (*val*=sign, 1) : 0;
	}

static hnumber(val) int *val;
	{
	static int digit;
	if (spaces()!='0' || toupper(nch())!='X') return 0;
	gch(); gch(); if (!hexdigit(&digit)) {lptr-=2; return 0;}
	*val=0; while (hexdigit(&digit)) {*val=(*val<<4)+digit; gch();}
	return 1;
	}

static hexdigit(digit) int *digit;
	{
	static int c;
	if (isdigit(c=toupper(ch()))) ;
	else if (c>='A' && c<='F') c-=(55-'0');
	else return 0;
	*digit=c-'0';
	return 1;
	}

static digits(val) int *val;
	{
	if (isdigit(ch()))
		{*val=0;
		while (isdigit(ch())) *val=*val*10+gch()-'0';
		return 1;
		}
	return 0;
	}

static subscript(val) int *val;
	{
	int l=(blanks(),lptr);
	return (num1(val,1) && spaces()==']')? 1 : (lptr=l, 0);
	}

static number(val,fun,sign) int *val,fun(),sign;
	{
	int l=(blanks(),lptr);
	return (fun(val,sign) && !(cheq('.') || cheq('L') || cheq('l')))? 1
		: (lptr=l, 0);
	}

static num1(val,sign) int *val,sign;
	{
	int num,flag=num2(val,sign);
	while (flag)
		{
		if (spaces()=='+') {gch(); flag=num2(&num,1); *val += num;}
		else if (cheq('-')) {gch(); flag=num2(&num,1); *val -= num;}
		else break;
		}
	return flag;
	}

static num2(val,sign) int *val,sign;
	{
	int num,flag=num3(val,sign);
	while (flag)
		{
		if (spaces()=='*') {gch(); flag=num3(&num,1); *val *= num;}
		else if (cheq('/')) {gch(); flag=num3(&num,1); *val /= num;}
		else if (cheq('%')) {gch(); flag=num3(&num,1); *val %= num;}
		else break;
		}
	return flag;
	}

static num3(val,sign) int *val,sign;
	{
	if (spaces()=='-') {gch(); sign=-sign;}
	if (spaces()=='(')
		{
		gch();
		if (!num1(val,1)) return 0;
		if (spaces()!=')') return 0;
		gch();
		}
	else if (hnumber(val)) ;
	else if (digits(val)) ;
	else if (primed(val)) ;
	else if (sizeo(val)) ;
	else return 0;
	*val*=sign;
	return 1;
	}

static sizeo(val) int *val;
	{
	if (spaces()==stsizeof)
		{int save[SAVENUM],typ=0,id=0,brack;
		intcopy(save,elem,SAVENUM);
		gch();
		if (brack=chmatch('('))
			{if (typename(0,&id,&typ)) id=declare(0,id,&typ);
			}
		if (!id)
			{char sname[namesize],*ptr;
			if (identifier(sname))
				{
				if ((ptr=findsym(sname)) && !ismacro(ptr))
					{id=ptr[ident];
					typ=*(int*)(ptr+type);
					elem[0]=*(int*)(ptr+dimension);
					elem[1]=*(int*)(ptr+dimension+2);
					}
				else undefined();
				}
			else illname();
			}
		if (isfunc(id)) error(57);
		if (brack) needbrack(')');
		*val=getsize(id,typ);
		intcopy(elem,save,SAVENUM);
		return 1;
		}
	return 0;
	}

static primed(val) int *val;
	{
	static unsigned int k,j;
	if (spaces()!='\'') return 0;
	gch(); k=0;
	while (ch()!='\'')
		{
		if (!ch()) break;
		j=litchar();
		k=(j>>8)? j : (k<<8)+j;
		}
	gch();
	*val=k;
	return 1;
	}

static quoted(val) int *val;
	{
	static int c,*lit;						/* int ! */
	if (!chmatch('"')) return 0;
	if (litptr+7>=litmax) return qfull();	/* returns 1 */
	lit=litq+litptr;
	lit[0]=0;
	litptr+=2;
	litq[litptr++]=abs;
	*val=litdist;
	while (ch()!='"')
		{
		if (!ch()) break;
		if(litptr+3>=litmax) return qfull();
		litq[litptr++]=c=litchar(); ++litdist; ++(*lit); /* store low byte */
		if (c>255) {litq[litptr++]=c>>8; ++litdist; ++(*lit);}
		}
	gch();
	litq[litptr++]=0;
	++litdist; ++(*lit);
	return 1;
	}

static qfull()
	{
	error(22);				/* string space exhausted */
	while (!chmatch('"'))
		if (!litchar()) break;
	return 1;
	}

/* Return current literal char & bump lptr	jeh 7/1/82 */

static litchar()
	{
	if (!(cheq(92) && nch())) return gch();
	gch();
	switch (ch())
		{case 'n':	gch(); return 2573;		/* 256*LF + CR */
		case 'r':	gch(); return 13;		/* CR */
		case 'e':	gch(); return 27;		/* ESC */
		case 'l': 	gch(); return 10;		/* LF */
		case 'd':	gch(); return base(10);	/* up to 3 decimal digits or lit */
		case 'x':	gch(); return hex();	/* up to 3 hex digits or literal */
		case 'b':	gch(); return 8;		/* BS */
		case 't':	gch(); return 9;		/* HT */
		case 'f':	gch(); return 12;		/* FF */
		default:	return base(8);			/* up to 3 octal digits or lit */
		}
	}

static hex()				/* read hex number, n = number of digits ( > 0) */
	{
	static int digit,i,res;
	i=3; res=0;
	while (i && hexdigit(&digit))
		{
		res=(res<<4)+digit;
		gch(); --i;
		}
	return (i==3)? gch() : res;
	}

static base(n) int n;
	{
	static int i,oct;
	i=3; oct=0;
	while (i && ch()>='0' && ch()<n+'0')
		{
		oct=oct*n+gch()-'0'; --i;
		}
	return (i==3)? gch() : oct;
	}

/* Put out assembler info before any code is generated */
static header()
	{
	if (output)
		{comment(); outln(message(0));
		comment(); nl();
		outline(".Z80");
		if (mainflg)
			{
			outline("ASEG\n\tORG\t100H\n\tLD\tHL,(6)");
			loadstk();
			library("CCGO");
			outline("PUSH\tBC");
			push();
			zcall("main");
			noutline(2,"POP\tBC");
			if (profile)
				{immed(); printlabel(firstfct); nl();
				library("CCCALLS");
				}
			outline("JP\t0");
			}
		}
	}

/* Print any assembler stuff needed after all code */

static trailer()
	{
	if (output)
		{if (trace) {printlabel(lastfct); outline("EQU\t0");}
		outline("END"); comment(); nl();
		comment(); outln(message(106));
		}
	}

/* determine type of binary operation */

static result(lval,lval2) int lval[],lval2[];
	{
	if (lval[intype] && lval2[intype]) lval[intype]=0;	/* ptr +- ptr => int */
	else if (lval2[intype]) intcopy(lval,lval2,LVAL);	/* ptr +- int => ptr */
	}

static intcopy(d,s,count) int d[],s[],count;
	{
	while (count--) d[count]=s[count];
	}

static store(lval) int lval[];
	{
	if (lval[symaddr] && !lval[memtype]) putmem(lval[symaddr]);
	else putstk(lval[memtype]);
	}

static locate(lval,kptr) int lval[],*kptr;	/* locate for storage */
	{
	if (*kptr!=2) return *kptr>0;
	getloc(lval,0);
	return *kptr=1;
	}

address(lval,k,off) int lval[],k,off;	/* find address of something */
	{
	if (plus(k)==3) loadsym(lval[symaddr],off);	/* static array or variable */
	else if (plus(k)==2) getloc(lval,off);		/* stacked array or variable */
	return k>0;
	}

static plus(i) int i;
	{
	if (i==32768 || i>=0) return i;
	return -i;
	}

static rvalue(lval,k) int lval[]; int k;
	{
	static int dist;
	static char *sym,syscall[]="INT ";
	if (k)
		{sym=lval[symaddr];
		if (k==2 && isint(lval[retype]) && (dist=*(int*)(sym+offset)-Zsp)<=16)
			{if (dist)
				{syscall[3]=dist+'A'-1;
				library(syscall);
				}
			else {mainpop(); mainpush();}
			}
		else if (k<0) address(lval,k,0);
		else
			{if (k!=2 && sym && !lval[memtype]) getmem(sym);
			else
				{if (k==2) getloc(lval,0);
				indirect(lval[memtype]);
				}
			}
		}
	return 0;
	}

static distance(sym,val) char *sym; int val;
	{
	static int off; off=0;
	if (sym>=ENDGLB && sym<strucptr || !sym)
		{printlabel(litlab);
		if (sym) off=*(int*)(sym+offset);
		}
	else outname(sym);
	if (off+val) {outbyte('+'); outdec(off+val);}
	}

static loadsym(sym,val) char *sym; int val;
	{
	immed(); distance(sym,val);
	nl();
	}

static outsym(sym) char *sym;
	{
	distance(sym,0);
	}
	
static outname(sname) char *sname;
	{
	outbyte('q'); outs(sname);
	}

/* Fetch a static memory cell into the primary register */

static getmem(sym) char *sym;
	{
	static typ;
	if (ispointer(sym[ident])) absolute(sym);
	else if (ischar(typ=*(int*)(sym+type)))
		{if (typ==CHAR)
			{outtab("LD\tA,("); outsym(sym); outln(")");
			extend();
			}
		else {absolute(sym); outline("LD\tH,0");}
		}
	else if (bigtype(typ))
		{loadsym(sym,0);
		dload();
		}
	else if (typ<=0) loadsym(sym,0);
	else absolute(sym);
	}

/* Fetch address of the specified auto variable */

static getloc(lval,off) int lval[],off;
	{
	mainload(*(int*)(lval[symaddr]+offset)-Zsp+off);
	addstk();
	}

/* Store the primary register into the specified static memory cell */

static putmem(sym) char *sym;
	{
	int noptr=!ispointer(sym[ident]),typ=*(int*)(sym+type);
	if (noptr && bigtype(typ))
		{loadsym(sym,0);
		dstore();
		}
	else if (noptr && ischar(typ))
		{outtab("LD\tA,L\n\tLD\t(");
		outsym(sym);
		outln("),A");
		}
	else if (noptr && typ<0)
		{outtab("LD\tDE,");
		distance(sym,0); nl();
		copystruc(typ);
		}
	else {outtab("LD\t("); outsym(sym); outln("),HL");}
	}

/* Store the specified object type in the primary register */
/* at the address on the top of the stack */

static putstk(typ) int typ;
	{
	if (bigtype(typ))
		{mainpop();
		dstore();
		}
	else if (ischar(typ))
		{zpop();
		outline("LD\tA,L\n\tLD\t(DE),A");
		}
	else if (typ<0)
		{zpop();
		copystruc(typ);
		}
	else popcall("CCPINT");
	}

/* Copy a whole structure or union */

static copystruc(typ) int typ;
	{
	bload(-typ);
	mainpush();
	outline("LDIR");
	mainpop();
	}

/* Fetch the specified object type indirect through the */
/* primary register into the primary register */

static indirect(typ) int typ;
	{
	if (ischar(typ))
		{if (typ==CHAR) library("CCGCHAR");
		else outline("LD\tL,(HL)\n\tLD\tH,0");
		}
	else if (bigtype(typ)) dload();
	else if (typ>0) library("CCGINT");
	}

static swap()
	{outline("EX\tDE,HL");
	}

static immed()
	{outtab("LD\tHL,");
	}

static mainload(n) int n;
	{immed(); outdln(n);
	}

static absolute(sym) char *sym;
	{
	immed();
	outs("("); outsym(sym); outln(")");
	}

tpush(lval) int lval[];
	{
	if (bigtype(lval[retype])) dpush();
	else mainpush();
	}

/* Push the primary floating point register onto the stack */

static dpush()
	{library("DPUSH"); Zsp-=DOUBLE;
	}
	
/* Push the primary floating point register,	*/
/* preserving the top value 					*/

static dpush2()
	{library("DPUSH2"); Zsp-=DOUBLE;
	}
	
static dswap()
	{library("DSWAP");
	}

	/* Push the primary register onto the stack */

static mainpush()
	{push(); Zsp-=2;
	}

static push()
	{outline("PUSH\tHL");
	}

static mainpop()
	{outline("POP\tHL"); popped();
	}
	
static zpush()
	{outline("PUSH\tDE"); Zsp-=2;
	}

static zpop()
	{outline("POP\tDE"); popped();
	}
	
static swapstk()
	{outline("EX\t(SP),HL");
	}

static addstk()
	{outline("ADD\tHL,SP");
	}

static loadstk()
	{outline("LD\tSP,HL");
	}

static call()
	{outtab("CALL\t");
	}

/* Call the specified subroutine name */

static zcall(sname) char *sname;
	{
	call();
	outname(sname); nl();
	}

/* Call a run-time library routine */

static library(sname) char *sname;
	{
	if (sname)
		{call();
		outln(sname);
		}
	}

static zret()
	{outline("RET");
	}

/* Jump to specified internal label number */

static jump(label) int label;
	{
	outtab("JP\t");
	printlabel(label); nl();
	}

static jumpnz(label) int label;
	{
	outtab("AND\tA\n\tSBC\tHL,DE\n\tJP\tNZ,");
	printlabel(label); nl();
	}

/* NOTE: In defstorage() never use "DS" because if the last	*/
/* assembly-command (or pseudo op) is a "DS", ZASM will not	*/
/* reserve space (only He knows why).						*/

static defstorage(i) unsigned i;
	{
	static unsigned j;
	if (i==2) {defword(); outdln(0);}
	else if (i)
		{while (i)
			{j=24; defbyte();
			while (j--)
				{outdec(0);
				if (j && --i) com();
				else {nl(); break;}
				}
			}
		}
	else nl();
	}

static defbyte()
	{outtab("DB\t");
	}

static defword()
	{outtab("DW\t");
	}

/* Modify the stack pointer to the new value indicated */

static modstk(newsp) int newsp;
	{
	int k=newsp-Zsp;
	if (k>=0 && k<13)
		{
		if (k&1) outline("INC\tSP");
		noutline(k/2,"POP\tBC");
		}
	else if (k<0 && k>-11)
		{
		noutline(-k/2,"PUSH\tHL");
		if (k&1) outline("DEC\tSP");
		}
	else
		{if (k>0) swap();
		mainload(k);
		addstk(); loadstk();
		if (k>0) swap();
		}
	return newsp;
	}

/* Multiply the primary register by the length of variable * object size */

static scale(lval) int lval[];
	{
	multiply(typesize(lval[intype])*second(lval));
	}

static multiply(size) int size;
	{
	if (!times(size))
		{mainpush();
		mainload(size); umul();
		}
	}

static doublereg()
	{outline("ADD\tHL,HL");
	}

static savereg()
	{
	outline("LD\tB,H\n\tLD\tC,L");
	doublereg();
	}

static onereg()
	{outline("ADD\tHL,BC");
	}

/* Multiply HL with 1..6,8,10,12,16.	*/
/* returns 1, if successful.			*/

static times(n) int n;
	{					
	if ((n>0 && n<=12 && !(n&1)) || n==16)
		{times(n/2); doublereg();
		}
	else if (n==3)
		{savereg(); onereg();
		}
	else if (n==5)
		{savereg(); doublereg(); onereg();
		}
	else return n==1;
	return 1;
	}
	
static bload(n) int n;
	{outtab("LD\tBC,"); outdln(n);
	}

static zload(n) int n;
	{outtab("LD\tDE,"); outdln(n);
	}

static popped()					/* 2 bytes popped off stack */
	{Zsp+=INT;
	}

static dpopped()				/* 6 bytes popped off stack */
	{Zsp+=DOUBLE;
	}

static popcall(str) char *str;
	{library(str); popped();
	}

static dpopcall(str) char *str;
	{library(str); dpopped();
	}

static extend()
	{library("CCSXT");
	}

static dload()
	{library("DLOAD");
	}

static dstore()
	{library("DSTORE");
	}

static zadd()
	{outline("ADD\tHL,DE");
	}

/* Subtract the primary register from the TOS (= value	*/
/* under the return address) (results in primary)		*/

static zsub()
	{popcall("CCSUB");
	}

/* Multiply the primary and TOS (unsigned) (results in primary) */

static umul()
	{popcall("CCUMUL");
	}

/* Divide the secondary register by the primary		*/
/* (quotient in primary, remainder in secondary)	*/

static div()
	{library("CCDIV");
	}

static udiv()
	{library("CCUDIV");
	}

/* Arithmetic shift right the secondary register number	*/
/* of times in primary (results in primary)				*/

static asr()
	{library("CCASR");
	}

static lsr()				/* Logical shift right for unsigned integers */
	{library("CCLSR");
	}

static asl()				/* Arithmetic left shift left */
	{popcall("CCASL");
	}

static inc()				/* Increment the primary register by one */
	{outline("INC\tHL");
	}

static dec()				/* Decrement the primary register by one */
	{outline("DEC\tHL");
	}

/************************************************/
/*												*/
/*	   <<<<<  End of SMALL-C Compiler  >>>>>	*/
/*												*/
/************************************************/
